
#-------------------------01.提取疾病样本--------------------------
load("C:\\Users\\Administrator\\Desktop\\243-11\\01-铜死亡基因的GO富集分析-CNV-PCA-表达分析\\01-铜死亡基因的PCA和多组箱线图\\Cu_death_Gene_boxplot_ROC_input.Rdata")

uniq.sym <- merge[merge$group=="Tumor",]
Cu <- data.frame(t(uniq.sym[,-1]),check.names = F)
save(Cu,file="TCGA_BRCA_1091_tumor_CuGene.Rdata")


#-------------------------
#BiocManager::install("ConsensusClusterPlus")
library(ConsensusClusterPlus)

########## 导入我的数据  ################
load("TCGA_BRCA_1091_tumor_CuGene.Rdata")
#dd <- read.table("uniCox_input.txt",sep="\t",header=T,check.names = F,row.names = 1)
#gene <- read.table("output_mRNA_selected.txt",header=F,sep="\t")
#load("C:\\Users\\Administrator\\Desktop\\XA0105\\00-data\\01-TCGA_LSCC\\diffSig.Rdata")

#uniq.sym1 <- uniq.sym[rownames(diffSig),]
uniq.sym1 <- Cu
uniq.sym1[,c(1:ncol(uniq.sym1))] <- apply(uniq.sym1[,c(1:ncol(uniq.sym1))],2,function(x){as.numeric(x)})
#dt <- as.matrix(uniq.sym1)

#sweep函数减去中位数进行标准化
dtt = sweep(uniq.sym1,1, apply(uniq.sym1,1,median,na.rm=T))
dt <- as.matrix(dtt)

#一步完成聚类
library(ConsensusClusterPlus)
#title=tempdir()
#dir.create("result1")  #新建文件夹
#title="E:\\小逗的工作内容\\项目-2021.2.5\\03-进行中项目\\进行的项目\\YQ279-12\\08-基于诊断标志物的疾病分子分型\\result"
#title=getwd()   #当前路径
results = ConsensusClusterPlus(dt,maxK=8,reps=300,pItem=0.9,pFeature=1,#title=title,
                              clusterAlg="hc",distance="pearson",#writeTable=TRUE,
                              seed=1262118388.71279,plot="png",tmyPal=NULL)
#seed=1262118388.71279,

###d中列-样本，行-features，可以是基因表达矩阵
#maxK：聚类结果中分类的最大数目，必须是整数
#reps:重抽样的次数
#pltem：样品的抽样比例，如pltem=0.8表示采用重抽样方案对样本的80%抽样，经过多次采样，找到稳定可靠的亚组分类
#pFeature：Feature的抽样比例
#clusterAlg：使用的聚类算法，"hc"用于层次聚类
#title：设置生成的文件路径
#distance：计算距离的方法，有pearson，sperson等
#tmyPal：可以指定一致性矩阵使用的颜色，默认使用白-蓝色
#seed：设置随机种子
#plot：不设置时图片结果仅输出屏幕，也可以设置输出为“pdf”,"png"等
#writeTable:若为True,则将一致性矩阵，ICL，log输出到csv文件

#聚类数目K=2，3，4，·····6，采用重抽样方案对样本的80%抽样，经过多次采样，找到稳定可靠的亚组分类。

##单纯导出样本分组可以用
cluster <- results[[3]][["consensusClass"]]
write.csv(cluster,"sample_group3.csv")
table(results[[3]][["consensusClass"]])   
# 1   2   3 
#473 296 322 


#------------分组信息
a <- read.csv("sample_group3.csv",header = T,sep=",",stringsAsFactors = F)
colnames(a) <- c("id","Subtype")
a$Subtype<-ifelse(a$Subtype=="1","Cluster1",
              ifelse(a$Subtype=="2","Cluster2","Cluster3"))
save(a,file="subtype_1091.Rdata")


#---导入time
time <- read.table("01_TCGA_BRCA_time.txt",header=T,sep="\t")

merge <- merge(time,a,by="id",all=F)
save(merge,file="survival_input_subtype.Rdata")


#----------------------俩个簇的生存分析-----------------------------
load("survival_input_subtype.Rdata")
sur <- merge

##################  C1和C2   ####################
library(survival)
library(survminer)

min(sur$futime)
sur$futime <- sur$futime/365
#rt <- sur[sur$Subtype!="Cluster1",]  ##画俩个簇的生存曲线
rt <- sur   #如果是两个簇

diff=survdiff(Surv(futime, fustat) ~Subtype,data =rt)
pValue=1-pchisq(diff$chisq,df=2)   #如果是三组做差异，df需要换成2
pValue=signif(pValue,4)
pValue=format(pValue, scientific = TRUE)

fit <- survfit(Surv(futime, fustat) ~ Subtype, data = rt)
surv_median(fit)  #查看高低风险组的中位生存时间
#risk=High_risk 4.068493 
# risk=Low_risk 6.312329

survdiff(Surv(futime, fustat) ~ Subtype, data = rt)

#整体比较
survdiff(Surv(futime, fustat) ~ Subtype, data = rt)
# N Observed Expected (O-E)^2/E (O-E)^2/V
# Subtype=Cluster1 462       56     65.7    1.4210     2.552
# Subtype=Cluster2 293       52     40.5    3.2829     4.526
# Subtype=Cluster3 314       42     43.9    0.0795     0.113
# Chisq= 4.8  on 2 degrees of freedom, p= 0.09


#俩俩比较
fit <- pairwise_survdiff(Surv(futime, fustat) ~ Subtype, data = rt,p.adjust.method = "none")
summary(fit)
# Cluster1 Cluster2
# Cluster2 0.037    -       
# Cluster3 0.539    0.128

#############  绘制生存曲线
pdf(file="survival_whole_new.pdf",onefile = FALSE,
    width =6,             #图片的宽度
    height =6)             #图片的高度
ggsurvplot(fit, 
           data=rt,
           conf.int=T,                     #是否展示置信区间
           pval=paste0("p=",pValue),
           pval.size=4,                       #pval字体大小
           risk.table=TRUE,
           #legend.labs=c("Cluster1", "Cluster2"),
          # legend.labs=c("Cluster2","Cluster3"),
            #legend.labs=c("Cluster1","Cluster3"),
           legend.labs=c("Cluster1", "Cluster2","Cluster3"),
           legend.title="Subtype",
           xlab="Time(years)",
           break.time.by = 2,            #调整间距
           risk.table.title="",
           #palette=c("red", "blue"),
           palette = c("#E7B800", "#2E9FDF","IndianRed"),  #C1,C2和C3
           #palette = c("#E7B800", "#2E9FDF"),      #C1和C2
          #palette = c("#E7B800", "IndianRed"),  #C1和C3
           #palette = c("#2E9FDF","IndianRed"),   #C2和C3
           #palette = c("#F08080", "#00E5EE"),
           risk.table.height=.25,
           risk.table.y.text.col = T, ## risk table左侧是否用对应分层变量的颜色注释
           risk.table.y.text = F, ## 是否展示分层变量的文本，如果不展示，则用颜色条进行展示
           #tables.theme = theme_cleantable(),
           ggtheme = theme_bw() ,# Change ggplot2 theme
           linetype = c('solid', 'solid','solid'), surv.median.line = 'hv',)

dev.off()

#------------------------whole-sur--------------
load("survival_input_subtype.Rdata")
sur <- merge

sur$futime <- sur$futime/365
#rt <- sur[sur$Subtype!="Cluster3",]  ##画俩个簇的生存曲线
#rt <- sur   #如果是两个簇

diff=survdiff(Surv(futime, fustat) ~Subtype,data =sur)
pValue=1-pchisq(diff$chisq,df=1)
pValue=signif(pValue,4)
pValue=format(pValue, scientific = TRUE)

fit <- survfit(Surv(futime, fustat) ~ Subtype, data = sur)
surv_median(fit)  #查看高低风险组的中位生存时间
#risk=High_risk 4.068493 
# risk=Low_risk 6.312329

#############  绘制生存曲线
pdf(file="survival_whole.pdf",onefile = FALSE,
    width =6,             #图片的宽度
    height =6)             #图片的高度
ggsurvplot(fit, 
           data=sur,
           conf.int=T,                     #是否展示置信区间
           pval=paste0("p=",pValue),
           pval.size=4,                       #pval字体大小
           risk.table=TRUE,
           #legend.labs=c("Cluster1", "Cluster2"),
           # legend.labs=c("Cluster2","Cluster3"),
           # legend.labs=c("Cluster1","Cluster3"),
           legend.labs=c("Cluster1", "Cluster2","Cluster3"),
           legend.title="Subtype",
           xlab="Time(years)",
           break.time.by = 2,            #调整间距
           risk.table.title="",
           #palette=c("red", "blue"),
           palette = c("#E7B800", "#2E9FDF","IndianRed"),  #C1,C2和C3
          # palette = c("#E7B800", "#2E9FDF"),      #C1和C2
           #palette = c("#E7B800", "IndianRed"),  #C1和C3
           #palette = c("#2E9FDF","IndianRed"),   #C2和C3
           #palette = c("#F08080", "#00E5EE"),
           risk.table.height=.25,
           risk.table.y.text.col = T, ## risk table左侧是否用对应分层变量的颜色注释
           risk.table.y.text = F, ## 是否展示分层变量的文本，如果不展示，则用颜色条进行展示
           #tables.theme = theme_cleantable(),
           ggtheme = theme_bw() ,# Change ggplot2 theme
           linetype = c('solid', 'solid','solid'), surv.median.line = 'hv',)

dev.off()


#--------------------------PCA-----------------
load("TCGA_BRCA_1091_tumor_CuGene.Rdata")
load("subtype_1091.Rdata")

dat <- Cu
#dat <- data.frame(t(merge[,-1:-2]),check.names = F)
#groups <- merge[,1:2]
identical(colnames(dat),a$id)

library("FactoMineR")
library("factoextra")
pca.plot = function(dat,col){
  
  df.pca <- PCA(t(dat), graph = FALSE)
  fviz_pca_ind(df.pca,
               geom.ind = "point",
               col.ind = col ,
               palette ="Dark2",
               pointshape=16,   #都是圆形
              # col.ind="black",
               #pointsize="cos2",   #圈大小不一样
               #palette ="jco",
               addEllipses = TRUE,
               legend.title = "Subtype"
  )
}

pdf("PCA_quan.pdf",height = 5,width=6)
pca.plot(dat,factor(a$Subtype))
dev.off()


#-------------------------UMAP-----------------------------
#环境设置
#使用国内镜像安装包
options("repos"= c(CRAN="https://mirrors.tuna.tsinghua.edu.cn/CRAN/"))
options(BioC_mirror="http://mirrors.ustc.edu.cn/bioc/")
#install.packages("Seurat")

#加载包
library(Seurat)
library(dplyr)
library(data.table)
library(cowplot)

Sys.setenv(LANGUAGE = "en") #显示英文报错信息
options(stringsAsFactors = FALSE) #禁止chr转成factor

load("TCGA_BRCA_1091_tumor_CuGene.Rdata")
Cu[1:4,1:4]

#expression_matrix <- data.frame(t(merge[,-1:-2]),check.names = F)
expression_matrix <- Cu
#无论是那种来源, 最终得到的expreesion_matrix都是表达矩阵, 行是基因名, 列是细胞名
expression_matrix[1:2,1:2]

#------------分组信息
load("subtype_1091.Rdata")
identical(colnames(expression_matrix),a$id)


#-----------------------构建Seurat对象------------------------
#使用CreateSeuratObject从表达量矩阵中构建SeuratObject
seurat_obj <- CreateSeuratObject(count = expression_matrix,
                                 min.cells = 0,min.features = 0
)
seurat_obj
FindVariableFeatures(seurat_obj)
seurat_obj <- NormalizeData(seurat_obj) |> FindVariableFeatures() |>ScaleData() |> RunPCA(verbose=FALSE)

ElbowPlot(seurat_obj, ndims = 100)  #用滚石图确定聚类和UMAP用的PC数

#thymus <- RunUMAP(seurat_obj, reduction = "pca", dims = 1:50,)
thymus <- RunUMAP(seurat_obj,dims = 1:7,
                  #n.neighbors = 20,
                  #no_genes=1000,
                  #min.dist = 0.01,
                  metric = "correlation")
#npcs = 100,
thymus@meta.data|> View()
thymus@meta.data$group <- a$Subtype
#thymus@meta.data$orig.ident <- "GSE136825"

library(ggplot2)
pdf("UMAP.pdf",height = 4,width=8)
p<-DimPlot(thymus, ncol = 2,reduction = "umap",
           #shape.by ="group",
           group.by = "group",
           label = F,)
p+#guides(fill = guide_legend(title = "Condition"))+
   scale_color_brewer(palette = "Dark2")+
   scale_fill_brewer(palette = "Dark2")+
  #scale_color_manual(values = "red") + #自定义配色
  labs(x="UMAP_1",y="UMAP_2",fill="",title="UMAP Plot")+
  theme(legend.position = "bottomright", 
        axis.text.y = element_text(size = 10,colour = "black"),
        #legend.text = element_text(size = 8),
        #legend.title = element_blank(),
        #legend.key.size = unit(0.2,'cm'),
        axis.title.y = element_text(size = 12, face = "bold"),
        panel.background = element_blank(), 
        axis.line = element_line(colour = "black", size = 0.3),
        plot.title = element_text(size = 12, face = "bold",hjust = 0.5)) +
  theme_bw()+
  #theme_classic()+
  #theme_base()+
  theme(plot.title = element_text(hjust = 0.5))
dev.off()


#--------------------诊断标志物在不同分型中的表达---------------------------
# load("gene_subtype.Rdata")
# rt <- merge[order(merge$Subtype),]
# 
# #热图
# #rt <- read.table('test.risk.txt',header = T,sep = '\t',check.names = F)
# rownames(rt) <- rt$id
# rt1=rt[c(3:ncol(rt))]
# rt1=t(rt1)
# 
# colnames(rt)
# annotation=data.frame(type=rt[,2])
# rownames(annotation)=rownames(rt)
# #ann_colors =list(type=c(Cluster1="#E41A1C",Cluster2="#377EB8",Cluster3="#4DAF4A"))
# ann_colors =list(type=c(Cluster1="#E41A1C",Cluster2="#377EB8"))
# library(pheatmap)
# pdf(file="heatmap.pdf",width = 9,height = 5)
# pheatmap(rt1, 
#          annotation=annotation, 
#          annotation_colors = ann_colors,
#          cluster_cols = FALSE,
#          fontsize_row=11,
#          scale="row",
#          show_colnames = F,
#          fontsize_col=3,
#          color = colorRampPalette(c("blue", "white", "red"))(50) )
# dev.off()

#----------------箱线图----------------------
library(tidyverse)
library(tidyr)
library(ggplot2)
require(ggpubr)
require(ggsci)
require(cowplot)
library(RColorBrewer)

hlaexp2 <- merge[,-1]
boxdata <- gather(hlaexp2,HLA,exp,2:ncol(hlaexp2))
#boxdata[,'exp'] <- sapply(boxdata[,'exp'],function(x){log2(x+1)})

#group分组列变成factor,boxplot按照L,H排列
#boxdata$group <- factor(boxdata$Subtype,levels = c('Cluster1','Cluster2',"Cluster3"))
boxdata$group <- factor(boxdata$Subtype,levels = c('Cluster1','Cluster2'))

#display.brewer.all()  #显示所有可用颜色
#mycol <- brewer.pal(3,'Dark2')
mycol <- brewer.pal(3,'Set1')[1:3]

#--------------梅花这个
pdf('DEGs_multibox.pdf',width =9,height =6)
ggboxplot(boxdata,x='HLA',y='exp',color ='group',
          ylab = 'Relative Expression',
          xlab ='',palette = mycol,  #nejm #jco #jama#npg#d3#aaas,"aaas"
          add ='jitter',add.params = list(size=1,shape=16),   #add ='jitter'
          width=0.5)+
  rotate_x_text(45)+
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=8),
        axis.title = element_text(size=10),
        legend.text = element_text(size=8),
        legend.title = element_text(size=10))+
  stat_compare_means(size = 3,aes(group=group),
                     label = 'p.signif',hide.ns = F,)  ##检验方法可以改

dev.off()


















#------------------------------尝试循环算显著性----------------------
load("gene_subtype.Rdata")
write.table(merge,"box_wil_kru.txt",row.names = F,quote = F,sep="\t")
rm(list=ls())
#setwd("C:/Users/Administrator/Desktop/rectum_9_25/25GEO验证/05Stromal_Immune_box/Immune_box")

inputFile="box_wil_kru.txt"                                         #?????ļ?
rt=read.table(inputFile,sep="\t",header=T,check.names=F)
#rt <- merge
#rt$ID <- rownames(merge)
#rt <- rt %>% select(ID,everything())
rt[,3:ncol(rt)] <- apply(rt[,3:ncol(rt)],2,function(x){as.numeric(x)})
clinical="Subtype"    ##定义临床类型                                                    #?????ٴ?????

apply(rt[,3:ncol(rt)],2,mean)
data.frame(a)


xlabel=vector()
tab1=table(rt[,clinical]);data.frame(tab1)
labelNum=length(tab1);data.frame(labelNum)    #查看stage列有几种类型

dotCol=c(2,3)
if(labelNum==3){
  dotCol=c(2,3,4)
}
if(labelNum==4){
  dotCol=c(2,3,4,5)
}
if(labelNum>4){
  dotCol=rainbow(labelNum)
}
for(i in 1:labelNum){
  xlabel=c(xlabel,names(tab1[i]) )
}

outTab=data.frame()

for(i in colnames(rt[,3:ncol(rt)])){
  rt1=rbind(expression=rt[,i],clinical=rt[,clinical])
  rt1=as.matrix(t(rt1))
  if(labelNum==2){
    wilcoxTest<-wilcox.test(expression ~ clinical, data=rt1)
  }else{
    wilcoxTest<-kruskal.test(expression ~ clinical, data = rt1)}
  pValue=wilcoxTest$p.value
  outTab=rbind(outTab,cbind(gene=i,pVal=pValue))
  pval=0
  if(pValue<0.001){
    pval=signif(pValue,4)
    pval=format(pval, scientific = TRUE)
  }else{
    pval=round(pValue,3)
  }
  
  b = boxplot(expression ~ clinical, data = rt1,outline = FALSE, plot=F) 
  yMin=min(b$stats)
  yMax = max(b$stats/5+b$stats)
  ySeg = max(b$stats/10+b$stats)
  ySeg2 = max(b$stats/12+b$stats)
  n = ncol(b$stats)
  
  ############## 画图  #####################
  
  outPdf=paste0(i,".",clinical,".pdf")
  pdf(file=outPdf,width=9,height=6,)
  par(mar = c(4,7,3,3))
  boxplot(expression ~ clinical, data = rt1,names=xlabel,
          ylab = i,col=dotCol,
          cex.main=1.6, cex.lab=1.4, cex.axis=1.3,ylim=c(yMin,yMax),outline = FALSE)
  segments(1,ySeg, n,ySeg);
  segments(1,ySeg, 1,ySeg2)
  segments(n,ySeg, n,ySeg2)
  text((1+n)/2,ySeg,labels=paste0("p=",pval),cex=1.5,pos=3)
  dev.off()
  
}
write.table(outTab,file=paste0(clinical,".xls"),sep="\t",row.names=F,quote=F)


?wilcox.test



