#----------------分组和临床信息merge-------------
cli <- read.table("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\04-clinical\\03_TCGA_BRCA_clinical_剔除MX等.txt",
                  header = T,sep='\t')
load("subtype_1091.Rdata")

merge <- merge(a,cli,by="id",all=F)
merge[1:4,1:4]
save(merge,file='subtype_clinical.Rdata')

#---------------画比例堆积图--------
#cankao:https://mp.weixin.qq.com/s?src=11&timestamp=1638343859&ver=3469&signature=4mg8-uH*NvP0G3E7ATYcxXAf9JYPgOR-yw-IZrphFa65lsdryHGwX-4ZWN6*spKAbC1pnLHi4leow2BSqEGIMZSgAI*oRt3i*H9j74wMSqs20d9QbMQcAJSZJCZLyMaR&new=1

library(ggplot2)
library(ggpubr)
library(ggpmisc)

load("subtype_clinical.Rdata")
colnames(merge)

library(RColorBrewer)
#display.brewer.all()  #显示所有可用颜色
# mycol <- brewer.pal(6,'Set1')
# print(mycol)

#-------M
# ###卡方检验
# print(chisq.test(table(merge$Subtype,merge$pathologic_M)))
# ##X-squared = 2.239, df = 2, p-value = 0.3265
# dat1 <- data.frame(
#   risk=c("Cluster1","Cluster1","Cluster2","Cluster2","Cluster3","Cluster3"),
#   type=c("M0", "M1","M0", "M1","M0", "M1"),
#   Patient_number=c(367,9,249,2,276,6)) 

#-------N
merge$age <- ifelse(merge$age>50,">50","<=50")
library(tidyverse)
library(tidyr)
library(ggplot2)
require(ggpubr)
require(ggsci)
require(cowplot)
library(RColorBrewer)
boxdata <- gather(merge,cli_name,cli,3:ncol(merge))
boxdata[1:4,1:4]

b <- boxdata %>%
   #filter(cli_name=="pathologic_N") %>%
   group_by(Subtype,cli,cli_name) %>%
   summarise(count=n())
save(b,file="duiji_input.Rdata")


#-----------------开始画图
load("duiji_input.Rdata")
load("subtype_clinical.Rdata")
###卡方检验
a <- print(chisq.test(table(merge$Subtype,merge$pathologic_N)))  #N
##X-squared = 13.818, df = 6, p-value = 0.03174
print(chisq.test(table(merge$Subtype,merge$pathologic_M)))  #race
#X-squared = 2.239, df = 2, p-value = 0.3265
print(chisq.test(table(merge$Subtype,merge$age)))  #age
#X-squared = 9.9954, df = 2, p-value = 0.006754
print(chisq.test(table(merge$Subtype,merge$pathologic_T)))  #T
#X-squared = 9.4279, df = 6, p-value = 0.1509
print(chisq.test(table(merge$Subtype,merge$tumor_stage.diagnoses)))  #stage
#X-squared = 7.0437, df = 6, p-value = 0.3168
print(chisq.test(table(merge$Subtype,merge$race.demographic)))  #race
#X-squared = 57.585, df = 8, p-value = 1.384e-09

p <- 1.384e-09
p.adjust(p,method = "bonferroni");p.adjust(p,method = "BH");
p.adjust(p,method = "holm");p.adjust(p,method = "hochberg");
p.adjust(p,method = "hommel");p.adjust(p,method = "BY")


unique(b$cli_name)
ttt <- b[b$cli_name=="tumor_stage.diagnoses",]


p1=ggplot(ttt,aes(x=Subtype,y=count,fill=cli))+
  geom_bar(stat = "identity",position = "fill",width=0.7)+
  #scale_fill_manual(values = c("#377EB8","#E41A1C"))+
  scale_fill_brewer(palette = "Set1")+
  #scale_fill_manual(values = c("red","blue"))+
  theme_bw()+
  theme(panel.grid = element_blank())#+
#stat_compare_means(aes(group=risk),method = "t.test",label="p.signif")

p2=p1+
  theme(panel.grid = element_blank(), axis.line = element_line(colour = 'black', size = 0), 
        panel.background = element_blank(),
        plot.title = element_text(size = 13, hjust = 0.5), 
        plot.subtitle = element_text(size = 11, hjust = 0.5),
        axis.text = element_text(size = 11, color = 'black'), 
        axis.title = element_text(size = 13, color = 'black')) +
  #facet_grid(.~cli_name) +   #????????????
  labs(#title="",   #添加主标题
    #subtitle="xxx",    #添加次标题
    #caption="Data source:xx cancer",  #添加脚注
    x='Cluster',y='',fill='type',            #x和y轴的名字
    #title = 'wilcox.test', 
    subtitle = 'p.value = 0.3168'
  )
p2

ggsave(p2,filename = 'stage_subtype.pdf',height = 6,width = 5)


#------------------热图
#参考：https://www.jianshu.com/p/332cc7cc3e16
rm(list = ls())
library(ComplexHeatmap)
library(RColorBrewer)
library(circlize)

load("subtype_clinical.Rdata")
rownames(merge)<- merge$id;
merge$age <- ifelse(merge$age>50,">50","<=50")
merge1 <- merge[order(merge$Subtype),]
#write.csv(merge1,"subtype_clinical_new_untreated.csv",quote = F,row.names = F)
merge1$race <- "race"
library(tidyverse)
merge1$race_demographic <- str_c(merge1$race,merge1$race.demographic,sep="_")
colnames(merge1)

dta <- data.frame(t(merge1[,-c(1,8,9)]),check.names = F)
dta[1:4,1:4]

data <- as.matrix(dta[-1,])
a = sort(unique(as.character(data)));head(a,20)#将所有临床排序，然后每个组按照样本顺序放置
data <- data[c(1:3,6:4),]

col_group_n = as.character(dta[1,])   #簇的分组
row_group_n = as.character(rownames(data)) 

Heatmap(data, name = "mat", 
        top_annotation = HeatmapAnnotation(Cluster = col_group_n),#注释条
        left_annotation = rowAnnotation(Clinical = row_group_n),
        column_split = col_group_n,     #切割列
        row_split = row_group_n,
        border = T,show_column_names = F)

#2.自定义颜色
#ComplexHeatmap有一个特点，如果你不指定配色的话，每次运行相同代码出来的图配色都不一样哦，所以接下来自己定义颜色。
#这里用到一个函数：colorRamp2，出自circlize包，可以根据你指定的几个颜色，生成一组渐变色。

# 主体热图的颜色-（即临床病理热图的颜色）
m = apply(data,1,function(x){length(unique(x))})
#按行计算独一无二字符串数目。
#display.brewer.all()
col_fun = colorRamp2(breaks = seq(0, 1, length.out = 12),
                     colors = brewer.pal(12,"Set3"))  #Set3
qz = sort(unique(as.character(data))); length(qz)#对dat里去重后临床病理排序并统计数目

colors = col_fun(seq(0, 1, length.out = length(qz))) #给31个临床病理附上颜色
head(colors)
names(colors) = qz   #临床病理与颜色对应
head(colors,20)


## 注释条的颜色---（即簇的颜色-clusetr）
col_group_n
color_an = brewer.pal(length(unique(col_group_n)),"Dark2")
color_an
names(color_an) = unique(col_group_n)
color_an    #cluster与颜色对应


##顶部注释---(即簇的名称和簇的颜色)
top_annotation = HeatmapAnnotation(cluster = col_group_n,
                                   col = list(cluster = color_an),
                                   show_legend = F,show_annotation_name = F)
f = Heatmap(data, col = colors,
            top_annotation = top_annotation,
           # row_split = ifelse(row_group=="x",""," "), #这一句是为了隐藏行分组的名字
            column_split = col_group_n,
            #row_split = row_group_n,
            show_heatmap_legend = F,
            border = T,show_column_names = F,row_names_side = "left",
            right_annotation = rowAnnotation(score = anno_text(1:nrow(data)))
)
f

# 主体热图的图例
k = 1
lgd = list()
for(i in 1:6){    #n行数据就写1：n
  un = sort(unique(data[i,]))
  ti = rownames(data)[i]    #行名的第i个
  lgd[[i]] = Legend(seq(0, 1, length.out = length(un)), labels = un,
                    title = ti, legend_gp = gpar(fill =colors[k:(k+length(un)-1)]))
  k = k + length(un)
}

# 注释的图例--指的是簇-cluster
cld = Legend(labels = c("Cluster1","Cluster2","Cluster3"), title = "Cluster", 
             legend_gp = gpar(fill = color_an))
color_an   
#Cluster1 Cluster2   Cluster3 
#"#1B9E77" "#D95F02" "#7570B3"


# 把各个图例合并在一起---(指的是簇和临床病理)
p = packLegend(list = c(cld,lgd),
               direction = "horizontal",gap = unit(0.6, "cm"))

draw(p)

## 主体和图例画到一起
pdf("heatmap_clinical.pdf",height = 6,width = 12)
draw(f,heatmap_legend_list = p,heatmap_legend_side = "bottom")
dev.off()

#--------------------画之前的多组临床-基因热图-------------
load("C:\\Users\\Administrator\\Desktop\\243-11\\02-一致性聚类-生存-UMAP-PCA\\TCGA_BRCA_1091_tumor_CuGene.Rdata")
Cu[1:4,1:4]
matrix <- data.frame(t(Cu))
matrix$id <- rownames(matrix)

load("subtype_clinical.Rdata")
rownames(merge)<- merge$id;
merge$age <- ifelse(merge$age>50,"dayu50","xiaoyudengyu50")
merge1 <- merge[order(merge$Subtype),]

#-----合并矩阵和clinical
merge <- merge(merge1,matrix,by="id",all=F)
rownames(merge) <- merge$id
mer <- merge[,-1]
colnames(mer)

cluster <- mer[,c(2:7,1)]
table(cluster$age)
colnames(cluster)

cluster$tumor_stage.diagnoses <- gsub(' ','',cluster$tumor_stage.diagnoses)
cluster$race.demographic <- gsub(' ','_',cluster$race.demographic)

df2 <- as.data.frame(t(mer[,8:ncol(mer)]))
library(RColorBrewer)

# annotation_col = data.frame(Age = factor(cluster$age),
#                             M = factor(cluster$),
#                             N = factor(cluster$N),
#                             T = factor(cluster$T),
#                             Stages = factor(cluster$stage),
#                             Race = factor(cluster$race),
#                             Subtype = factor(cluster$Subtype))  ##分组，legend名称：Type,这里可以调整显示顺序

#给分组设置颜色.注意格式
display.brewer.all()
ann_age <-  brewer.pal(6,"PuRd")
#ann_age <- c('#FBB4A1','#B3CDE3')
#mycol1 <- brewer.pal(6,'Set1')
#ann_M <- c('#7FC97F','#BEAED4')
#a <- brewer.pal(6,'')
ann_M <- brewer.pal(6,'PuBuGn')
ann_N <- brewer.pal(8,'YlGnBu')
ann_stage <- brewer.pal(10,'BrBG')
ann_T <- brewer.pal(6,'YlOrRd')
ann_race <- brewer.pal(5,'Dark2')
ann_Subtype <- brewer.pal(6,'Set2')

table(cluster$race.demographic)
ann_colors = list(age = c(dayu50=ann_age[3],xiaoyudengyu50=ann_Subtype[1]),
                  pathologic_M = c(M0=ann_M[4],M1=ann_N[6]),
                  pathologic_N = c(N0=ann_N[1],N1=ann_N[2],N2=ann_N[3],N3=ann_N[4]),
                  pathologic_T = c(T1=ann_T[1],T2=ann_T[3],T3=ann_T[4],T4=ann_T[6]),
                  tumor_stage.diagnoses = c(stageI=ann_stage[7],stageII=ann_stage[8],stageIII=ann_stage[9],stageIV=ann_stage[10]),
                  race.demographic = c(black_or_african_american=ann_race[1],white=ann_stage[5],asian=ann_T[2],american_indian_or_alaska_native=ann_race[2],Unknow=ann_race[5]),
                  Subtype = c(Cluster1=ann_Subtype[2],Cluster2=ann_Subtype[3],Cluster3=ann_Subtype[5]))


#绘制热图
library(pheatmap)

cluster <- cluster[order(cluster$Subtype),]
df <- df2[,rownames(cluster)]

identical(rownames(cluster),colnames(df))
table(cluster$Subtype)

pdf("multiGroup_heatmap--3.pdf",height=10,width=10)
pheatmap(df, 
         annotation=cluster, 
         #annotation_legend = FALSE,
         annotation_colors = ann_colors,
         color = colorRampPalette(c("blue", "white", "red"))(50),
         cluster_cols =F,
         fontsize=8,
         fontsize_row=8,
         scale="row",
         show_colnames=F,
         fontsize_col=3,
         cutree_col = 2,
         gaps_col=c(376,627),
         main = "Cluster1(n=376)  Cluster2(n=251)   Cluster3(n=282)")
dev.off()




#---------------------------参考的例子----------------
rm(list = ls())
library(ComplexHeatmap)
library(RColorBrewer)
library(circlize)
discrete_mat = matrix(sample(letters[1:4], 100, replace = TRUE), 10, 10)
Heatmap(t(discrete_mat), 
        column_split = discrete_mat[, 1],
        top_annotation = HeatmapAnnotation(group = discrete_mat[, 1]),
        border = T)

#切割、加边框、加注释这样的操作，参数还是蛮好找的。
# 编一个类似于上面那张图的输入数据，画画看。
# 每一行都是有重复值的不同向量，并且向量的取值数量都是有限的。
sl = function(letter,n = sample(2:4,1),ncol = 100){
  sample(paste0(letter,1:n),ncol,replace = T)
}
table(sl("a"))

dat = t(sapply(letters[1:10], sl))
rownames(dat) = LETTERS[1:10]   #行名-也就是临床病例的名称：M，N，stage等
colnames(dat) = paste0("M",1:ncol(dat))  #列名为样本名称，TCGA-。。。
dat[1:4,1:4]
# M1   M2   M3   M4  
# A "a1" "a1" "a1" "a1"
# B "b3" "b4" "b1" "b3"
col_group = rep(c("C1","C2","C3"),times = c(30,40,30))  #100列分成3个组
#subtype行-C1,C2,C3
row_group = rep(c("x","y"),times = c(6,4))   #10行分成2个组
#临床病理分组

Heatmap(dat, name = "mat", 
        top_annotation = HeatmapAnnotation(cluster = col_group),#注释条
        left_annotation = rowAnnotation(foo1 = row_group),
        column_split = col_group,     #切割列
        row_split = row_group,
        border = T,show_column_names = F)

#2.自定义颜色
#ComplexHeatmap有一个特点，如果你不指定配色的话，每次运行相同代码出来的图配色都不一样哦，所以接下来自己定义颜色。
#这里用到一个函数：colorRamp2，出自circlize包，可以根据你指定的几个颜色，生成一组渐变色。


# 主体热图的颜色-（即临床病理热图的颜色）
m = apply(dat,1,function(x){length(unique(x))})
#按行计算独一无二字符串数目。

col_fun = colorRamp2(breaks = seq(0, 1, length.out = 12),
                     colors = brewer.pal(12,"Set3"))
qz = sort(unique(as.character(dat))); length(qz)#对dat里去重后临床病理排序并统计数目

colors = col_fun(seq(0, 1, length.out = length(qz))) #给31个临床病理附上颜色
head(colors)
names(colors) = qz   #临床病理与颜色对应
head(colors)


## 注释条的颜色---（即簇的颜色-clusetr）
col_group
color_an = brewer.pal(length(unique(col_group)),"Dark2")
color_an
names(color_an) = unique(col_group)
color_an    #cluster与颜色对应


##顶部注释---(即簇的名称和簇的颜色)
top_annotation = HeatmapAnnotation(cluster = col_group,col = list(cluster = color_an),show_legend = F,show_annotation_name = F)
f = Heatmap(dat, col = colors,
            top_annotation = top_annotation,
            row_split = ifelse(row_group=="x",""," "), #这一句是为了隐藏行分组的名字
            column_split = col_group,
            show_heatmap_legend = F,
            border = T,show_column_names = F,row_names_side = "left",
            right_annotation = rowAnnotation(score = anno_text(1:nrow(dat)))
)
f

#3.自定义图例
#前面有个参数是show_heatmap_legend = F，show_legend = F,是不显示主体与注释图例的意思。
#这里之所以不显示是为了自定义图例。否则呢，主体热图的图例就会全部放在一起，不能按行来显示哦。

# 主体热图的图例
k = 1
lgd = list()
for(i in 1:10){    #n行数据就写1：n
  un = sort(unique(dat[i,]))
  ti = rownames(dat)[i]    #行名的第i个
  lgd[[i]] = Legend(seq(0, 1, length.out = length(un)), labels = un,
                    title = ti, legend_gp = gpar(fill =colors[k:(k+length(un)-1)]))
  k = k + length(un)
}

# 注释的图例--指的是簇-cluster
cld = Legend(labels = c("C1","C2","C3"), title = "Cluster", 
             legend_gp = gpar(fill = color_an))
color_an   
#C1        C2        C3 
#"#1B9E77" "#D95F02" "#7570B3"


# 把各个图例合并在一起---(指的是簇和临床病理)
p = packLegend(list = c(cld,lgd),
               direction = "horizontal",gap = unit(0.6, "cm"))

draw(p)

## 主体和图例画到一起
draw(f,heatmap_legend_list = p,heatmap_legend_side = "bottom")



