######Video source: http://ke.biowolf.cn
######Homepage: http://www.biowolf.cn/
######Wechat Public：biowolf_cn
######E-mail：biowolf@foxmail.com
######Wechat: 18520221056

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma")

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("GSVA")

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("GSEABase")

#setwd("C:\\Users\\biowolf\\Desktop\\ssGSEA\\07.ssGSEA")          #设置工作目录
#inputFile="C:\\Users\\Administrator\\Desktop\\GY0112_new\\01-批次处理-差异分析-铁代谢DEG鉴定-PPI-富集分析\\01-批次处理+差异分析\\uniq.symbol_60_sva.txt"                                         #输入文件
load("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\03_TCGA_BRCA_uniq.symbol_1204.Rdata")
data2[1:4,1:4]

gmtFile="immune.gmt"                                           #GMT文件

#引用包
library(GSVA)
library(limma)
library(GSEABase)

#读取输入文件，并对输入文件处理
#rt=read.table(inputFile,sep="\t",header=T,check.names=F)
#rt[1:3,1:3]
#rt=as.matrix(rt)
#rownames(rt)=rt[,1]
#exp=rt[,2:ncol(rt)]
#dimnames=list(rownames(exp),colnames(exp))
#mat=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
#mat=avereps(mat)
#mat=mat[rowMeans(mat)>0,]

# rownames(rt)=rt[,1]
# rt <- rt[,-1]
mat <- as.matrix(data2)

geneSet=getGmt(gmtFile, 
               geneIdType=SymbolIdentifier())

#ssgsea分析
ssgseaScore=gsva(mat, geneSet, method='ssgsea', kcdf='Gaussian', abs.ranking=TRUE)
#定义ssGSEA score矫正函数
normalize=function(x){
  return((x-min(x))/(max(x)-min(x)))}
#对ssGSEA score进行矫正
ssgseaOut=normalize(ssgseaScore)
ssgseaOut=rbind(id=colnames(ssgseaOut),ssgseaOut)
write.table(ssgseaOut,file="ssgseaOut.txt",sep="\t",quote=F,col.names=F)


#---------------------多组免疫细胞箱线图-------------------------
# install.packages("tidyr")
# install.packages("ggplot2")
# install.packages("tidyverse")
library(tidyverse)
library(tidyr)
library(ggplot2)
require(ggpubr)
require(ggsci)
require(cowplot)
library(RColorBrewer)


#Type=read.table("group_60_pca.txt",sep="\t",check.names=F,header=T)
load("C:\\Users\\Administrator\\Desktop\\243-11\\02-一致性聚类-生存-UMAP-PCA\\subtype_1091.Rdata")

colnames(Type)
Type=a[order(a[,2]),]
#Type <- Type[,1:2]  ##riskScore和risk

score=read.table("ssgseaOut.txt",sep="\t",check.names=F,row.names=1,header=T)
score <- data.frame(t(score))
score[1:4,1:4]
score=score[Type$id,]
#colnames(Type)=c("riskSc","risk")
cluster=cbind(Type,score)
rownames(cluster) <- cluster$id
cluster=cluster[,-1]
cluster[1:4,1:4]
hlaexp <- cluster
save(hlaexp,file="ssGSEA_boxinput.Rdata")
write.csv(hlaexp,"ssGSEA_boxinput.csv",quote = F)


boxdata <- gather(hlaexp,HLA,exp,2:ncol(hlaexp))
#boxdata$HLA=gsub("\\.","\\-",boxdata$HLA)
#gather之后的boxdata包含三列信息，表达量信息列，分组信息列，基因名称信息列
boxdata[,'exp'] <- sapply(boxdata[,'exp'],function(x){log2(x+1)})


table(hlaexp$Subtype)
boxdata$Subtype <- factor(boxdata$Subtype,levels = c('Cluster1','Cluster2',"Cluster3"))

#display.brewer.all()  #显示所有可用颜色
#mycol <- brewer.pal(2,'Dark2')
#mycol <- brewer.pal(2,'Set1')[1]

#--------------梅花这个
pdf('ssGSEA_box.pdf',width =8,height =5)
ggboxplot(boxdata,x='HLA',y='exp',color ='Subtype',
          ylab = 'Relative Expression',
          xlab ='',palette = "Set1",  #nejm #jco #jama#npg#d3#aaas,"aaas"
          add ='jitter',add.params = list(size=0.6,shape=16),   #add ='jitter'
          width=0.5)+
  rotate_x_text(45)+
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=8),
        axis.title = element_text(size=10),
        legend.text = element_text(size=8),
        legend.title = element_text(size=10))+
  stat_compare_means(size = 3,aes(group=Subtype),
                     label = 'p.signif',hide.ns = F)  ##检验方法可以改
#,method = 'wilcox.test'
dev.off()


#-------------多组小提琴箱线图-------------------
pdf('ssGSEA_box_ggplot2.pdf',width =9,height =6)
ggplot(boxdata,aes(x=HLA,y=exp,fill=Subtype))+  ##fill=vs：按vs分组对ggplot全局进行颜色设置
  #geom_violin()+
  geom_boxplot(width=0.5)+
  # scale_fill_manual(values= mycol)+
  scale_fill_brewer(palette="Set1")+
  labs(x = "", y = "Relative Expression",title="", colour = "black") +
  # coord_flip()+  #???????????Ե?
  #facet_grid(.~HLA) +   #????????????
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=10),    ##坐标轴标签的大小
        axis.title = element_text(size=10),   ###纵坐标字的大小
        legend.text = element_text(size=8),
        legend.title = element_text(size=8))+
  stat_compare_means(size =3,aes(group=Subtype),
                     label = 'p.signif',hide.ns = F,label.x = 1.5,)+
  #theme_bw()+
  rotate_x_text(45)
dev.off()


#------------------------multiheatmap-------------------------
load("C:\\Users\\Administrator\\Desktop\\243-11\\03-热图和比例图展示不同簇间临床特征的分布情况\\subtype_clinical.Rdata")
rownames(merge)<- merge$id;
merge$age <- ifelse(merge$age>50,"dayu50","xiaoyudengyu50")

score=read.table("ssgseaOut.txt",sep="\t",check.names=F,row.names=1,header=T)
score <- data.frame(t(score))
score[1:4,1:4]
score2 <- cbind(id=rownames(score),score)

mer <- merge(merge,score2,by="id",all=F)
rownames(mer) <- mer$id
merge <- mer[,-1]
save(merge,file="ssgseaOut_clinical_subtype.Rdata")

#---------分组
colnames(merge)
cluster <- merge[,c(2:7,1)]
colnames(cluster)

cluster$tumor_stage.diagnoses <- gsub(' ','',cluster$tumor_stage.diagnoses)
cluster$race.demographic <- gsub(' ','_',cluster$race.demographic)

df2 <- as.data.frame(t(merge[,8:ncol(merge)]))
library(RColorBrewer)

# annotation_col = data.frame(Age = factor(cluster$age),
#                             M = factor(cluster$),
#                             N = factor(cluster$N),
#                             T = factor(cluster$T),
#                             Stages = factor(cluster$stage),
#                             Race = factor(cluster$race),
#                             Subtype = factor(cluster$Subtype))  ##分组，legend名称：Type,这里可以调整显示顺序

#给分组设置颜色.注意格式
display.brewer.all()
ann_age <-  brewer.pal(6,"PuRd")
#ann_age <- c('#FBB4A1','#B3CDE3')
#mycol1 <- brewer.pal(6,'Set1')
#ann_M <- c('#7FC97F','#BEAED4')
#a <- brewer.pal(6,'')
ann_M <- brewer.pal(6,'PuBuGn')
ann_N <- brewer.pal(8,'YlGnBu')
ann_stage <- brewer.pal(10,'BrBG')
ann_T <- brewer.pal(6,'YlOrRd')
ann_race <- brewer.pal(5,'Dark2')
ann_Subtype <- brewer.pal(6,'Set1')

table(cluster$race.demographic)
ann_colors = list(age = c(dayu50=ann_age[3],xiaoyudengyu50=ann_Subtype[4]),
                  pathologic_M = c(M0=ann_M[4],M1=ann_N[6]),
                  pathologic_N = c(N0=ann_N[1],N1=ann_N[2],N2=ann_N[3],N3=ann_N[4]),
                  pathologic_T = c(T1=ann_T[1],T2=ann_T[3],T3=ann_T[4],T4=ann_T[6]),
                  tumor_stage.diagnoses = c(stageI=ann_stage[7],stageII=ann_stage[8],stageIII=ann_stage[9],stageIV=ann_stage[10]),
                  race.demographic = c(black_or_african_american=ann_race[1],white=ann_stage[5],asian=ann_T[2],american_indian_or_alaska_native=ann_race[2],Unknow=ann_race[5]),
                  Subtype = c(Cluster1=ann_Subtype[1],Cluster2=ann_Subtype[2],Cluster3=ann_Subtype[3]))


#绘制热图
library(pheatmap)

cluster <- cluster[order(cluster$Subtype),]
df <- df2[,rownames(cluster)]

identical(rownames(cluster),colnames(df))
table(cluster$Subtype)

pdf("multiGroup_heatmap_ssgsea.pdf",height=6,width=10)
pheatmap(df, 
         annotation=cluster, 
         #annotation_legend = FALSE,
         annotation_colors = ann_colors,
         color = colorRampPalette(c("blue", "white", "red"))(50),
         cluster_cols =F,
         fontsize=8,
         fontsize_row=8,
         scale="row",
         show_colnames=F,
         fontsize_col=3,
         #cutree_col = 2,
         #gaps_col=c(376,627),
         main = "Cluster1(n=376)  Cluster2(n=251)   Cluster3(n=282)")
dev.off()







#--------------------------计算Hub基因和差异免疫细胞的相关性分析-----------------------
library(ggplot2)
library(dplyr)
Sys.setenv(LANGUAGE = "en") #显示英文报错信息
options(stringsAsFactors = FALSE) #禁止chr转成factor

#ssGSEA_output.csv，免疫细胞矩阵，列是免疫细胞，行是样本，由FigureYa71ssGSEA产生。如果对免疫浸润不感兴趣，就把ssGSEA_output.csv换成其他类型的数据，例如临床指标什么的，只要保证样品名跟easy_input_expr.csv一致就好了。
#easy_input_expr.csv，基因表达矩阵，列是样本，行是基因。行也可以是转录本，甚至是临床信息。
#genelist.txt，基因名，将要计算这些基因跟免疫浸润的相关性。要求跟easy_input_expr.csv里的基因名一致。

### 读入ssGSEA的结果；或CIBERSORT结果
tcga_gsva <- read.table("ssgseaOut.txt",sep="\t",row.names = 1,header=T,check.names = F)
DE <- read.table("DEimmuneCell_4.txt",sep="\t",header=F,check.names=F)

tcga_gsva[1:4,1:4]
tcga_gsva <- data.frame(t(tcga_gsva[DE$V1,]))

### 读入表达量数据
# <- data.table::fread("matrix_375_treated.txt", data.table = F, )
#colnames(tcga_expr) <- gsub("\\.","-",colnames(tcga_expr))
## 第一列转为行名
#rownames(tcga_expr) <- tcga_expr[,1]
#tcga_expr <- tcga_expr[,-1]
load("C:\\Users\\Administrator\\Desktop\\GY0112_new\\01-批次处理-差异分析-铁代谢DEG鉴定-PPI-富集分析\\01-批次处理+差异分析\\uniq.symbol_60_sva.Rdata")
uniq.symbol_sva[1:3,1:3]
tcga_expr <- uniq.symbol_sva


## 调整免疫矩阵中的样本顺序
#tcga_gsva <- tcga_gsva[colnames(tcga_expr),]
tcga_expr[1:3,1:4]
tcga_expr <- tcga_expr[,rownames(tcga_gsva)]
tcga_expr[1:3,1:4]


### 读入感兴趣的基因
#risk <- read.table("risk.txt",sep="\t",header=T)
#colnames(risk)
#genelist <- colnames(risk)[4:11]
genelist <- read.table("keyGeneList_5.txt",header=F)
genelist <- genelist$V1

###############################  3.批量计算相关性  #####################################################
#输入一个基因，即可返回跟免疫基因的相关性、p值，其中method可以改为“pearson”或“kendall”
gene <- genelist
immuscore <- function(gene){
  y <- as.numeric(tcga_expr[gene,])
  colnames <- colnames(tcga_gsva)
  do.call(rbind,lapply(colnames, function(x){
    dd  <- cor.test(as.numeric(tcga_gsva[,x]), y , method="spearman")
    data.frame(gene=gene,immune_cells=x,cor=dd$estimate,p.value=dd$p.value )
  }))
}

#以FOXP3为例，测试一下函数
#immuscore("FOXP3")

###############################  4.批量计算genelist跟免疫浸润相关性的结果  ####################
data <- do.call(rbind,lapply(genelist,immuscore))
head(data)

#保存到文件
write.csv(data, "correlation_spearman.csv", quote = F, row.names = F)


###############################  5.增加一列，区分p值的大小 ###############################
#使用两个ifelse实现三分类
data$pstar <- ifelse(data$p.value < 0.05 & abs(data$cor)>0.3,
                     ifelse(data$p.value < 0.01 & abs(data$cor)>0.3,"**","*"),
                     "")
data$pstar[1:20]
data$r <- round(data$cor,2)

ggplot(data, aes(immune_cells, gene)) + 
  geom_tile(aes(fill = cor), colour = "white",size=1)+
  scale_fill_gradient2(low = "#2b8cbe",mid = "white",high = "#e41a1c")+
  geom_text(aes(label=pstar),col ="black",size = 3)+
  theme_minimal()+# 不要背景
  theme(axis.title.x=element_blank(),#不要title
        axis.ticks.x=element_blank(),#不要x轴
        axis.title.y=element_blank(),#不要y轴
        axis.text.x = element_text(angle = 45, hjust = 1),# 调整x轴文字
        axis.text.y = element_text(size = 8))+#调整y轴文字
  #调整legen
  labs(fill =paste0(" * p < 0.05","\n\n","** p < 0.01","\n\n","Correlation"))
ggsave("correlation_spearman.pdf",width =6,height = 4)







