
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")

BiocManager::install("edgeR")
library(edgeR)
library(limma)
####################################
#data_FPKM <- read.table("03_uniq.symbol_KIRC_602.txt",sep="\t",header=T,check.names = F)

load("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\03_TCGA_BRCA_uniq.symbol_1204.Rdata")
data2[1:4,1:4]

data_FPKM <- data2

#data_FPKM <- read.csv("matrix_VaD_Control.csv",header=T,check.names = F)
#data_FPKM <- data_FPKM[rowMeans(data_FPKM)>0,]
#(data_FPKM) <- data_FPKM[,1]
#data_FPKM <- data_FPKM[,-1]
boxplot(data_FPKM[,500:ncol(data_FPKM)],las=2)    ##查看数据分布，看是否进行标准化
#data_FPKM<-log2(data_FPKM+1)   #标准化
##data_FPKM<-rpkm(data_FPKM,gene.length =2000,normalized.lib.sizes = FALSE,lib.size = NULL,log=TRUE,prior.count =2)

# load("C:\\Users\\Administrator\\Desktop\\243-11\\02-一致性聚类-生存-UMAP-PCA\\subtype_1091.Rdata")
# clinical <- a[a$Subtype!="Cluster1",]
# table(clinical$Subtype)

##### 样本不按顺序的时候
clinical<-read.table("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\04_group_113_1091.txt",sep="\t",header=F)
clinical<-t(clinical)
clinical<-data.frame(clinical)
colnames(clinical)<-c("var1","var2")
rownames(clinical)<-clinical$var1
data_FPKM <- data_FPKM[,clinical$var1]  ##由于样本数目不一致

clinical<-clinical[as.vector(colnames(data_FPKM)),]  #如果跑不通这步就#掉
group<-factor(clinical$var2)
design <- model.matrix(~0+group, data=clinical)
colnames(design) <- c(levels(group))
identical(colnames(data_FPKM),rownames(clinical))

fit<-lmFit(data_FPKM,design)
contrast.matrix <- makeContrasts("Tumor-Normal",levels=design)  ##看clinical文件的命名
fit2<-contrasts.fit(fit,contrast.matrix)
fit2<-eBayes(fit2)
result1<-topTable(fit2,coef=1,adjust="BH",number=dim(data_FPKM)[1])

#write.table(result1,file="DEGs_information.txt",sep="\t",quote=F,row.names=T)
write.csv(result1,file="Tumor-Normal_DEGs_informationw.csv",quote=F,row.names=T)

save(clinical,file="Tumor-Normal_group.Rdata")
save(result1,file="Tumor-Normal_DEGs_informationw.Rdata")
load("Tumor-Normal_DEGs_informationw.Rdata")


#########################   logFc=0.5,P.Val=0.05   #######################
colnames(result1)
logFc=0.5
p=0.05
diffSig = result1[(result1$P.Value < p & (result1$logFC>logFc | result1$logFC<(-logFc))),]
diffSig <- cbind(gene=rownames(diffSig),diffSig)
write.table(diffSig, file="Tumor-Normal_diffSig_logFC0.5_p0.05_4878.xls",row.names=F,sep="\t",quote=F)
save(diffSig,file="Tumor-Normal_diffSig.Rdata")

#UP
diffUp = result1[(result1$P.Value < p & (result1$logFC>logFc)),]
diffUp <- cbind(gene=rownames(diffUp),diffUp)
write.table(diffUp, file="Tumor-Normal_up_logFC0.5_p0.05_2441.xls",row.names=F,sep="\t",quote=F)

#Down
diffDown = result1[(result1$P.Value < p & (result1$logFC<(-logFc))),]
diffDown <- cbind(gene=rownames(diffDown),diffDown)
write.table(diffDown, file="Tumor-Normal_down_logFC0.5_p0.05_2437.xls",row.names=F,sep="\t",quote=F)














###############  DE_MDG箱线图  ####################
load("438_交集基因矩阵.Rdata")
load("group.Rdata")
load("diffSig.Rdata")

DE_MDG_Exp <- data_FPKM[diffSig$gene,]
save(DE_MDG_Exp,file="120_genes-DE_MDG_EXP.Rdata")
DE_MDG_Exp_t <- as.data.frame(t(DE_MDG_Exp))
dd <- cbind(id=rownames(DE_MDG_Exp_t),DE_MDG_Exp_t)

colnames(clinical) <- c("id","group")
merg <- merge(clinical,dd,by="id",all=F)
order <- merg[order(merg$group),]


install.packages("tidyr")
install.packages("ggplot2")
install.packages("tidyverse")
library(tidyverse)
library(tidyr)
library(ggplot2)
require(ggpubr)
require(ggsci)
require(cowplot)
library(RColorBrewer)

#hlaexp<-read.table("input.txt",sep="\t",header=T,check.names = F)

rownames(order) <- order$id
hlaexp <- order[,-1]
colnames(hlaexp)
hlaexp <- hlaexp[order(hlaexp[,1]),]

boxdata <- gather(hlaexp,HLA,exp,2:ncol(hlaexp))
#boxdata$HLA=gsub("\\.","\\-",boxdata$HLA)
#gather之后的boxdata包含三列信息，表达量信息列，分组信息列，基因名称信息列
boxdata[,'exp'] <- sapply(boxdata[,'exp'],function(x){log2(x+1)})

#group分组列变成factor,boxplot按照L,H排列

#boxdata$group <- factor(boxdata$T,levels = c("T1","T2","T3","T4"))
boxdata$group <- factor(boxdata$group,levels = c('Normal','Tumor'))
mycol <- brewer.pal(2,'Dark2')

pdf('12_DE_MDG_boxplot.pdf',width =8,height =6)
#pdf('gender.pdf',width =9,height = 6)
ggboxplot(boxdata,x='HLA',y='exp',color ='group',
          ylab = 'Relative Expression',
          xlab ='',palette = mycol,  #nejm #jco #jama#npg#d3#aaas#futurama
          add ='jitter',add.params = list(size=0.8,shape=16),   #add ='jitter'
          width=0.4)+   #组多的时候width值调大一点点
  rotate_x_text(45)+
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=12),    ##坐标轴标签的大小
        axis.title = element_text(size=12),   ###纵坐标字的大小
        legend.text = element_text(size=10),
        legend.title = element_text(size=10))+
  stat_compare_means(size =5,aes(group=group),
                     label = 'p.signif',method = 'wilcox.test',hide.ns = F)  ##检验方法可以改
##2组--wilcox.test，多组kruskal.test
dev.off()

############ 标记火山图  ####################

if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")
BiocManager::install(c("ggrepel","ggplot"))

res <- read.csv("DEGs_information-DE_MDG_new.csv")

#定义显著性
library(ggplot2)
library(ggrepel)

#labelGene<- read.csv("top20_gene.csv")$x 
#abelGene<- read.table("top40.txt",header=T) 
#DEGs <- res[order(res$logFC),]
#labelGene<-DEGs$X[c(1:10,19542:19551)]
#labelGene<- diffSig$gene

load("diffSig.Rdata")
labelGene<- diffSig$gene

colnames(res)
res$label <- ifelse(res$X %in% labelGene,res$X,"" )  #要标记的，label=基因，无需标记的，label=""
Significant=ifelse((res$P.Value< 0.05 & abs(res$logFC)> 1), ifelse(res$logFC > 1,"Up","Down"), "Not")#绘制火山图
p = ggplot(res, aes(logFC, -log10(P.Value),col=Significant))+
  geom_point()+
  #geom_point(alpha=0.4, size=3.5) +
  scale_color_manual(values=c("#004BFB", "#BFBFBF", "#F91F10"))+
  labs(title = " ")+xlab("log2FC")+
  #max(-log10(res$P.Value));min(res$logFC);max(res$logFC)
  xlim(-4,4)+ylim(0,80)+
  geom_vline(xintercept=c(-1,1), colour="black", linetype="dashed")+
  geom_hline(yintercept = -log10(0.05),colour="black", linetype="dashed")+
  theme(plot.title = element_text(size = 16, hjust = 0.5, face = "bold"))+
  theme_bw()
p
p1 <- p +geom_text_repel(data= res,aes(logFC, -log10(P.Value),label = label),
                         size = 3,
                         box.padding = unit(0.5, "lines"),
                         point.padding = unit(0.8, "lines"), 
                         segment.color = "black", 
                         max.overlaps =30,    #调整大会显示多
                         show.legend = FALSE)

p1

#保存为图片
pdf("vocano_DEGs.pdf",width=7,height=6)
print(p1)
dev.off()













