
#----------------------------GEO数据集PCA-验证评分模型-生存-箱线图--------------

#----------------------PCA-------------------------
library(gmodels)
library(scatterplot3d)
library(vegan)
library(ggplot2)
library(ggrepel)
library(limma)
library(survival)

exp <- read.table("E:\\小逗的工作内容\\项目-2021.2.5\\01-完成的项目-2020-2021.6\\38_YQ256-11_BRCA_20220228\\02-我的分析过程\\01-data\\05-GEO数据集-模型验证\\02-GSE20685\\05_GSE20685_uni.symbol.txt",
                  header=T,row.names=1,sep="\t")
exp[1:4,1:4]

intersect <- read.table("04_gene_Sig_exp.txt",head = TRUE,row.names=1,sep="\t")
intersectGene_exp <- exp[rownames(exp) %in% colnames(intersect),]
save(intersectGene_exp,file="GSE20685_ConsensusCluster_input.Rdata")
# load("38DEG_subtype_1091.Rdata")
# # a[1:4,1:3]
# # groups <- a[,-3]

# dat <- dat[a$id,]
# dat <- data.frame(t(dat),check.names = F)

dat <- intersectGene_exp
b <- matrix(0,nrow = nrow(dat), ncol = ncol(dat))
for(i in 1:ncol(dat)){
  b[,i] = dat[ ,i]
}
colnames(b) <- colnames(dat)
rownames(b) <- rownames(dat)
data <- t(b)

# rownames(groups) <- groups$id
# group <- levels(groups$Subtype)
# 
# group_number <- length (group)
#cols <- c("red", "blue", "green", "purple", "cyan", "darkblue", "seagreen", "steelblue","DarkTurquoise", "Sienna", "Chocolate", "BlueViolet", "Magenta", "brown", "gray", "darkred", "pink", "orange")
# cols <- rainbow(group_number, s = 1, v = 1, start = 0, end = max(1, group_number - 1)/group_number, alpha = 1)
# pchs <- c(15, 17, 18, 8, 4, 5, 1, 2, 6, 7, 3, 9, 10, 11, 12, 13, 14)
# legend_cex <- 1
# if (group_number > 18) {
#   pchs <- c(pchs, pchs)
#   legend_cex <- 0.5
# }
# pch <- rep(19, dim(data)[1])
# col <- rep("black", dim(data)[1])
# for (i in 1:length(group)){
#   pch[groups[rownames(data),2] == group[i]] <- pchs[i]
#   col[groups[rownames(data),2] == group[i]] <- cols[i]
# }

data.pca <- fast.prcomp(data, retx = TRUE, scale = TRUE, center = TRUE)
PCData <- data.frame(data.pca$x[,1:2])
#PCData <- cbind(PCData,groups$Subtype)
#colnames(PCData) <- c("PC1","PC2","PC3","group")
#colnames(PCData) <- c("PC1","PC2","group")

a <- summary(data.pca)
b <- a[4]$importance
PC1 <-as.numeric(data.pca$x[,1])
PC2 <-as.numeric(data.pca$x[,2])
#PC3 <-as.numeric(data.pca$x[,3])
write.table(data.pca$x[,1:2],"PCA_GSE58812.xls",sep="\t")


#--------------------打分----------------------
pca <- read.table("PCA_GSE20685.xls",header=T,sep="\t")
pca$id <- rownames(pca)

#---导入time
time <- read.table("E:\\小逗的工作内容\\项目-2021.2.5\\01-完成的项目-2020-2021.6\\38_YQ256-11_BRCA_20220228\\02-我的分析过程\\01-data\\05-GEO数据集-模型验证\\02-GSE20685\\05_GSE20685_time.txt",header=T,sep="\t")

OS_GSE <- merge(time,pca,by="id",all=F)
OS_GSE[1:4,1:4]
save(OS_GSE,file="05_GSE58812_predict_input.Rdata")
write.table(OS_GSE,'05_GSE58812_predict_input.txt',sep = '\t',quote = F,row.names = F)

#--------------验证模型
load("05_predict_input.Rdata")  
OS[1:3,1:4]
load("05_GSE20685_predict_input.Rdata")
OS_GSE[1:3,1:4]

rownames(OS) <- OS$id
multi <- OS[,-1]
multiCox=coxph(Surv(futime, fustat) ~ ., data = multi)
multiCoxSum=summary(multiCox)

#验证集风险评分
Score=predict(multiCox,type="risk",newdata = OS_GSE)
coxGene=rownames(multiCoxSum$coefficients)
coxGene=gsub("`","",coxGene)
outCol=c("id","futime","fustat",coxGene)
rt_vali <- cbind(OS_GSE[,outCol],Score)
rt_vali$group <- ifelse(rt_vali$Score>=median(rt_vali$Score),'High CuSig score','Low CuSig score')
rt_vali <- rt_vali[order(rt_vali$group,decreasing = T),]
write.table(rt_vali, file="06_GSE20685_CuSig_score.txt",sep="\t",quote=F,row.names=F)


#筛选阈值
rownames(rt_vali) <- rt_vali$id
res.cut <- surv_cutpoint(rt_vali, time = "futime", event = "fustat",
                         variables = c('Score'),minprop = 0.2)
# pdf('train.cutoff.pdf',width = 4,height = 4.5)#确定种子后再画这个图
# plot(res.cut, "riskScore", palette = "npg")
# dev.off()
res.cat <- surv_categorize(res.cut)
colnames(res.cat)[3] <- 'group' 
res.cat$Score <- rt_vali[rownames(res.cat),]$Score
nlow1 <- nrow(res.cat[res.cat$score=='low',])
nhigh1 <- nrow(res.cat[res.cat$score=='high',])
#res.cat$id <- rownames(res.cat)
res.cat$id <- rt_vali$id
#modelgene <- as.vector(modelgene)
#res.cat <- merge(res.cat,rt[,c('id',modelgene)],by='id')
colnames(res.cat)
res.cat <- res.cat[order(res.cat$Score,decreasing = T),]
res.cat$group <- ifelse(res.cat$group=="low","Low CuSig score","High CuSig score")
res.cat <- res.cat[,c(5,1,2,4,3)]
write.table(res.cat, file="06_GSE20685_CuSig_cutpoint.txt",sep="\t",quote=F,row.names=F) 
save(res.cat,file="06_GSE20685_CuSig_cutpoint.Rdata")


#---------------------------验证集生存曲线-----------------------------
library(survival)
library(survminer)
library(RColorBrewer)
#display.brewer.all()

rt=read.table("06_GSE20685_CuSig_cutpoint.txt",header=T,sep="\t")
rt$futime <- rt$futime/365
diff=survdiff(Surv(futime, fustat) ~group,data = rt)
pValue=1-pchisq(diff$chisq,df=1)
pValue=signif(pValue,4)
pValue=format(pValue, scientific = TRUE)

fit <- survfit(Surv(futime, fustat) ~ group, data = rt)
#############  绘制生存曲线
pdf(file="GSE20685_CuSig_survival_最佳阈值.pdf",onefile = FALSE,
    width = 6,             #图片的宽度
    height =5)             #图片的高度
ggsurvplot(fit, 
           data=rt,
           conf.int=TRUE,
           pval=paste0("p=",pValue),
           pval.size=4,                       #pval字体大小
           risk.table=TRUE,
           legend.labs=c('High CuSig score','Low CuSig score'),
           legend.title="Group",
           xlab="Time(years)",
           break.time.by = 2,            #调整间距
           risk.table.title="Number at CuSig score",
           #palette=c("red", "blue"),
           palette = c("#E7B800", "#2E9FDF"),
           #palette = c("#E7B800", "#2E9FDF"),
           #palette = c("#F08080", "#00E5EE"),
           #palette =brewer.pal(5,'Set1') ,
           risk.table.height=.3,
           tables.theme = theme_cleantable(),
           ggtheme = theme_bw() ,# Change ggplot2 theme
           linetype = c('solid', 'solid'), surv.median.line = 'hv',)
dev.off()


#----------------------------PD-L1和PD1在高低评分下的箱线图----------------
rt=read.table("06_GSE20685_CuSig_cutpoint.txt",header=T,sep="\t")
rt$futime <- rt$futime/365
rt[1:4,1:ncol(rt)]

exp <- read.table("E:\\小逗的工作内容\\项目-2021.2.5\\01-完成的项目-2020-2021.6\\38_YQ256-11_BRCA_20220228\\02-我的分析过程\\01-data\\05-GEO数据集-模型验证\\02-GSE20685\\05_GSE20685_uni.symbol.txt",
                  header=T,row.names=1,sep="\t")
exp[1:4,1:4]
data2 <- exp

GENE <- c("PD1","CD279","SLEB2","PD-1","PD-L1","CD274","PDL1")
gene_exp <- data2[GENE,]
gene_exp1 <- na.omit(gene_exp)
PD_L1 <- data.frame(t(gene_exp1[,rt$id]))

identical(rt$id,rownames(PD_L1))

#--合并CD274（即PD-L1）和高低评分
score_PD <- cbind(rt,PD_L1)
save(score_PD,file="08_GSE20685_CuSigScore_PD-L1.Rdata")


load("08_GSE20685_CuSigScore_PD-L1.Rdata")
colnames(score_PD)

merge <- score_PD[order(score_PD$group,decreasing = T),]
merge$group

colnames(merge)
p1=ggboxplot(merge,
             x='group',          #选择X轴用哪列数据
             y='CD274',      #选择Y轴用哪列数据
             color='group',       #颜色根据哪一列决定
             bxp.errorbar=T,     #是否添加误差bar，一般添加美观
             bxp.errorbar.width=0.2,  
             palette="Dark2",      #颜色风格
             #palette = "jama",
             #add = "point",
             add='jitter')+         #是否添加箱线图上的点点
  stat_compare_means(label ="p.format",label.x = 1.5)
#comparisons = my_comparisons,
#label = "p.signif":显示显著性 
#method = "t.test"  ：显示用的检验方法，默认wilcox.test法      
p1
##########  2.添加标题  #################################################
p2=p1+
  labs(title="",   #添加主标题
       #subtitle="xxx",    #添加次标题
       #caption="Data source:xx cancer",  #添加脚注
       x='',y='PD-L1 Expression'            #x和y轴的名字
  )
p2

############   4.设置主题   #############################################
p3=p2+
  theme(
    plot.title=element_text(color='black',size=12,hjust=0.5),
    plot.subtitle=element_text(color='black',size=12,hjust=0.5),
    plot.caption=element_text(color='black',size=12,face='italic',hjust=1),
    axis.text.x=element_text(color='black',size=12,angle=0),  
    axis.text.y=element_text(color='black',size=12,angle=0),
    axis.title.x=element_text(color='black',size=12,angle=0),
    axis.title.y=element_text(color='black',size=12,angle=90),   
  )
#p3        
pdf(file="GSE20685_CuSigScore_PDL1.pdf",width=6,height=6)
p3 
dev.off()

#-------------------验证集的一致性聚类划分亚型-----------------------------------
load("GSE20685_ConsensusCluster_input.Rdata")
uniq.sym1 <- intersectGene_exp

uniq.sym1[,c(1:ncol(uniq.sym1))] <- apply(uniq.sym1[,c(1:ncol(uniq.sym1))],2,function(x){as.numeric(x)})
#dt <- as.matrix(uniq.sym1)

#sweep函数减去中位数进行标准化
dtt = sweep(uniq.sym1,1, apply(uniq.sym1,1,median,na.rm=T))
dt <- as.matrix(dtt)

#一步完成聚类
library(ConsensusClusterPlus)
#title=tempdir()
#dir.create("result1")  #新建文件夹
#title="E:\\小逗的工作内容\\项目-2021.2.5\\03-进行中项目\\进行的项目\\YQ279-12\\08-基于诊断标志物的疾病分子分型\\result"
#title=getwd()   #当前路径
results = ConsensusClusterPlus(dt,maxK=8,reps=300,pItem=0.9,pFeature=1,#title=title,
                               clusterAlg="pam",distance="spearman",#writeTable=TRUE,
                               seed=1262118388.71279,plot="png",tmyPal=NULL)

write.csv(results[[5]][["consensusClass"]],"GSE20685_sample_group5.csv")
table(results[[5]][["consensusClass"]])   
# 1  2  3  4  5 
#64 95 41 71 56

#------------分组信息
a <- read.csv("GSE20685_sample_group5.csv",header = T,sep=",",stringsAsFactors = F)
colnames(a) <- c("id","Subtype")
a$C <- "Cluster"
library(tidyverse)
a$Subtype <- str_c(a$C,a$Subtype,sep="")
#a$Subtype<-ifelse(a$Subtype=="1","Cluster1",
#             ifelse(a$Subtype=="2","Cluster2","Cluster3"))
save(a,file="GSE20685_subtype_327.Rdata")

#----------------------打分与亚型的箱线图-------------------
load("GSE20685_subtype_327.Rdata")
a[1:4,1:3]

rt=read.table("06_GSE20685_CuSig_cutpoint.txt",header=T,sep="\t")
rt$futime <- rt$futime/365
rt[1:4,1:ncol(rt)]

CuSig_subtype <- merge(a[,-3],rt,by="id",all=F)
save(CuSig_subtype,file = "09_GSE20685_CuSig_subtype_cutpoint.Rdata")


library(ggplot2)
library(ggpubr)
library(magrittr)
library(ggsignif)
library(RColorBrewer)

load("09_GSE20685_CuSig_subtype_cutpoint.Rdata")
colnames(CuSig_subtype)

#rt$Type<-as.factor(rt$group)   #数据的gender列设为属性
#as.factor(rt$gender)     #观察dose的factor有哪些

# merge <- merge[order(merge$stage),]
# my_comparisons <- list(c('stage i','stage ii'),c('stage i','stage iii'),
#                        c('stage i','stage iv'),c('stage ii','stage iii'),
#                        c('stage ii','stage iv'),c('stage iii','stage iv'))
merge <- CuSig_subtype[order(CuSig_subtype$Subtype),]
merge$Subtype
# my_comparisons <- list(c('Cluster1','Cluster2'),c('Cluster2','Cluster3'),
#                        c('Cluster3','Cluster4'),c('Cluster4','Cluster5'),
#                        c('Cluster1','Cluster3'),c('Cluster1','Cluster4'),
#                        c('Cluster1','Cluster5'),c('Cluster2','Cluster4'),
#                        c('Cluster2','Cluster5'),c('Cluster3','Cluster4'),
#                        c('Cluster3','Cluster5'),c('Cluster4','Cluster5')
#                        )

colnames(merge)
p1=ggboxplot(merge,
             x='Subtype',          #选择X轴用哪列数据
             y='Score',      #选择Y轴用哪列数据
             color='Subtype',       #颜色根据哪一列决定
             bxp.errorbar=T,     #是否添加误差bar，一般添加美观
             bxp.errorbar.width=0.2,  
             palette="Set1",      #颜色风格
             #palette = "jama",
             #add = "point",
             add='jitter')+         #是否添加箱线图上的点点
  stat_compare_means(label ="p.format",label.x = 1.5)
#comparisons = my_comparisons,
#label = "p.signif":显示显著性 
#method = "t.test"  ：显示用的检验方法，默认wilcox.test法      
p1
##########  2.添加标题  #################################################
p2=p1+
  labs(title="",   #添加主标题
       #subtitle="xxx",    #添加次标题
       #caption="Data source:xx cancer",  #添加脚注
       x='',y='CuSig score'            #x和y轴的名字
  )
p2

############   4.设置主题   #############################################
p3=p2+
  theme(
    plot.title=element_text(color='black',size=12,hjust=0.5),
    plot.subtitle=element_text(color='black',size=12,hjust=0.5),
    plot.caption=element_text(color='black',size=12,face='italic',hjust=1),
    axis.text.x=element_text(color='black',size=12,angle=0),  
    axis.text.y=element_text(color='black',size=12,angle=0),
    axis.title.x=element_text(color='black',size=12,angle=0),
    axis.title.y=element_text(color='black',size=12,angle=90),   
    #lengend.title=element_text(color='black',size=16),
    #lengend.text=element_text(color='black',size=16),
    # axis.line.y=element_line(color='black',linetype='solid'),
    # axis.line.x=element_line(color='black',linetype='solid'),
    # panel.border=element_rect(linetype='solid',size=1.2,fill=NA) #图四周框起来
  )
#p3        
pdf(file="GSE20685_CuSig_score_subtype_cutpoint.pdf",width=6,height=6)
p3 
dev.off()


#--------------ggplot2画图
p <- ggplot(merge,aes(x=Subtype,y=Score,fill=Subtype))+
  geom_violin()+
  geom_boxplot(width=0.2,position = position_dodge(0.9))+
  scale_fill_brewer(palette="Set1")+
  labs(x = "", y = "CuSig score",title="", colour = "black") +
  #theme_bw()+
  theme(
    plot.title=element_text(color='black',size=12,hjust=0.5),
    plot.subtitle=element_text(color='black',size=12,hjust=0.5),
    plot.caption=element_text(color='black',size=12,face='italic',hjust=1),
    axis.text.x=element_text(color='black',size=12,angle=0),  
    axis.text.y=element_text(color='black',size=12,angle=0),
    axis.title.x=element_text(color='black',size=12,angle=0),
    axis.title.y=element_text(color='black',size=12,angle=90),   
    #lengend.title=element_text(color='black',size=16),
    #lengend.text=element_text(color='black',size=16),
    # axis.line.y=element_line(color='black',linetype='solid'),
    # axis.line.x=element_line(color='black',linetype='solid'),
    # panel.border=element_rect(linetype='solid',size=1.2,fill=NA) #图四周框起来
  )+
  stat_compare_means(aes(group=Subtype),label ="p.format",label.x = 1.5)#+
# geom_signif(annotations = c("",""),
#             y_position = c(25,30),
#             xmin = c(0.8,1.8),
#             xmax = c(1.2,2.2),
#             tip_length = c(0.02,0.4,0.02,0.2) )
p
pdf(file="GSE20685_CuSig_score_subtype_cutpoint_ggplot2.pdf",width=6,height=6)
p 
dev.off()
