#使用国内镜像安装包
#options("repos"= c(CRAN="https://mirrors.tuna.tsinghua.edu.cn/CRAN/"))
#install.packages("ggalluvial")
library(ggalluvial)
Sys.setenv(LANGUAGE = "en") #显示英文报错信息
options(stringsAsFactors = FALSE) #禁止chr转成factor


load("07_CuSig_subtype_cutpoint.Rdata")
colnames(CuSig_subtype)
CuSig_subtype$group <- ifelse(CuSig_subtype$group=="High CuSig score","High","Low")
colnames(CuSig_subtype)[2] <- "Cluster"

load("subtype_1091.Rdata")
df <- merge(a,CuSig_subtype[,c(1,2,6)],by="id",all=F)
rownames(df) <- df$id
df <- df[,-1]

UCB_lodes <- to_lodes_form(df[,1:ncol(df)],
                           axes = 1:ncol(df),
                           id = "Cohort")
dim(UCB_lodes)

ggplot(UCB_lodes,
       aes(x = x, stratum = stratum, alluvium = Cohort,
           fill = stratum, label = stratum)) +
  scale_x_discrete(expand = c(0, 0)) + 
  
  #用aes.flow参数控制线从哪边来，颜色就跟哪边一致。
  #默认是forward，此处用backward。
  geom_flow(width = 1/4,aes.flow = "forward") +
  
  #coord_flip() + #旋转90度
  geom_stratum(alpha = .9,width = 1/5) +
  geom_text(stat = "stratum", size = 3,color="black") +
  
  #如果分组少，可以用scale_fill_brewer。修改type和palette两个参数选择配色方案，更多配色方案参考下图，分别对应type参数的“Seq”、“qual”、“Div”
  scale_fill_brewer(type = "Div", palette = "Set1") +
  
  #如果分组太多，就要用前面自己写的配色方案
  #scale_fill_manual(values = mycol) +
  #scale_fill_brewer(palette = "Set1")+
  
  xlab("Subtype1  Subtype2  CuSig score") + ylab("") +
  theme_bw() + 
  theme(panel.grid =element_blank()) + 
  theme(panel.border = element_blank()) + 
  theme(axis.line.x = element_blank(),axis.ticks = element_blank(),axis.text.x = element_blank()) + #显示分组名字
  ggtitle("") +
  guides(fill = FALSE) 

ggsave("sankey.pdf",height = 6,width =5)

