#-------------------------CNV
require(cowplot)
require(tidyverse)
require(ggplot2)
require(ggsci)
require(ggpubr)

cnv <- data.table::fread("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\04-拷贝数变异（cnv）\\TCGA-BRCA.cnv.tsv.gz",
                         data.table = F)
load("06_CuSig_cutpoint.Rdata")
colnames(res.cat)

ge <- merge(res.cat,cnv,by.x='id',by.y="sample",all.x=F) 
colnames(ge)[1:20]


merge <- ge[order(ge$Score,decreasing = F),]
merge$group

colnames(merge)
p1=ggboxplot(merge,
             x='group',          #选择X轴用哪列数据
             y='value',      #选择Y轴用哪列数据
             color='group',       #颜色根据哪一列决定
             bxp.errorbar=T,     #是否添加误差bar，一般添加美观
             bxp.errorbar.width=0.2,  
             palette="Dark2",      #颜色风格
             #palette = "jama",
             #add = "point",
             add='jitter')+         #是否添加箱线图上的点点
  stat_compare_means(label ="p.format",label.x = 1.5)
#comparisons = my_comparisons,
#label = "p.signif":显示显著性 
#method = "t.test"  ：显示用的检验方法，默认wilcox.test法      
p1
##########  2.添加标题  #################################################
p2=p1+
  labs(title="",   #添加主标题
       #subtitle="xxx",    #添加次标题
       #caption="Data source:xx cancer",  #添加脚注
       x='',y='SCNV'            #x和y轴的名字
  )
p2

############   4.设置主题   #############################################
p3=p2+
  theme(
    plot.title=element_text(color='black',size=12,hjust=0.5),
    plot.subtitle=element_text(color='black',size=12,hjust=0.5),
    plot.caption=element_text(color='black',size=12,face='italic',hjust=1),
    axis.text.x=element_text(color='black',size=12,angle=0),  
    axis.text.y=element_text(color='black',size=12,angle=0),
    axis.title.x=element_text(color='black',size=12,angle=0),
    axis.title.y=element_text(color='black',size=12,angle=90),   
  )
#p3        
pdf(file="SCNV.pdf",width=6,height=6)
p3 
dev.off()
