library(pheatmap)
Sys.setenv(LANGUAGE = "en") #显示英文报错信息
options(stringsAsFactors = FALSE) #禁止chr转成factor

#表达矩阵
load("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\03_TCGA_BRCA_uniq.symbol_1204.Rdata")
data2[1:4,1:4]
#dat <- read.table("matrix_risk.txt",sep = "\t",row.names = 1,header = T,stringsAsFactors = F,check.names = F)

#分组信息
load("06_CuSig_cutpoint.Rdata")
#ann <- read.table("easy_input_anno.txt",sep = "\t",row.names = 1,header = T,stringsAsFactors = F,check.names = F)
#head(ann)
#table(ann$ImmClust)
###               ImmClust
## CESC-A0TN-01A       C2
ann <- data.frame(ImmClust=res.cat[,c(5)])
rownames(ann) <- res.cat$id
head(ann)
ann$ImmClust <- ifelse(ann$ImmClust=="High CuSig score","C1","C2")
head(ann)
#table(ann$ImmClust)

dat <- data2[,rownames(ann)]
dat[1:3, 1:3]
matrix <- cbind(id=rownames(dat),dat)
write.table(matrix,"matrix_submapInput.txt",quote = F,sep="\t",row.names = F)


TIDE <- dat
# 这里为了得到比较好的结果，采用two direction median centered
TIDE <- sweep(TIDE,2, apply(TIDE,2,median,na.rm=T))
TIDE <- sweep(TIDE,1, apply(TIDE,1,median,na.rm=T))
write.table(TIDE,"TIDE_input.self_subtract",sep = "\t",row.names = T,col.names = NA,quote = F)

#------------------------------------#
# 请参照文件夹中的TIDE使用教程.docx完成该部分#
#---##-----------------------------------绘图------------------------
DF <- read.csv("TIDE_output.csv",sep=",",header=T,check.names=F) 
#rt <- read.table("risk.txt",sep="\t",row.names=1,header=T,check.names=F) 
load("06_CuSig_cutpoint.Rdata")
colnames(res.cat)

Cu_TIDe <- merge(DF,res.cat[,c(1,5)],by.x="Patient",by.y="id",all=F)
rownames(Cu_TIDe) <- Cu_TIDe$Patient
Cu_TIDe11 <- Cu_TIDe[,-1]
save(Cu_TIDe11,file="High_Low_score-TIDE.Rdata")

#开始画图
#用ggplot2画图，用ggpubr算p value。
library(ggpubr)
library(RColorBrewer)
#display.brewer.all()  #显示所有可用颜色

merge1 <- Cu_TIDe11[order(Cu_TIDe11$group),]   #为age升序排列
pdf("TIDE.box.pdf",height=6,width=6)
ggboxplot(merge1, x= 'group', y='TIDE',
          ylab = "TIDE value", color ="group" , palette="Set1",merge = "flip", add="jitter")+
  stat_compare_means(size = 4,aes(group= group))
dev.off()

#------------------------------------#

#---------------------submap---------------------------------------------------
# 参照文件夹中TIDE使用教程得到输出文件TIDE_output.csv
TIDE.res <- read.csv("TIDE_output.csv",header = T,row.names = 1,check.names = F,stringsAsFactors = F)
ann$TIDE <- TIDE.res[rownames(ann),"Responder"]
print(table(ann$TIDE,ann$ImmClust))

# 检验免疫治疗响应性和亚型是否相关，p<0.05表示相关
print(fisher.test(table(ann$TIDE,ann$ImmClust))) 

save(ann,dat,TIDE,TIDE.res,file="before.Rdata")
load("before.Rdata")

#----------------------submap预测亚型的免疫治疗响应性
#输入表达矩阵和样品信息，整理成submap所需的格式，在线运行后输出SubMap_SubMapResult.txt用于画图。

# 自定义函数用来产生submap需要的数据格式
generateInputFileForSubMap <- function(in_gct, gct_file, cls_file, sam_info, type_name = "type"){
  in_gct <- data.frame(GeneID=rownames(in_gct),
                       description="na",
                       in_gct, 
                       stringsAsFactors = F,
                       check.names = F)
  cat("#1.2\n", file = gct_file)
  cat(nrow(in_gct),"\t",ncol(in_gct)-2,"\n", file = gct_file, append = T)
  cat(paste(colnames(in_gct), collapse = "\t"),"\n", file = gct_file, append = T)
  for(i in 1:nrow(in_gct)) cat(paste(in_gct[i,], collapse = "\t"),"\n", file = gct_file, append = T)
  
  cat(nrow(sam_info),length(levels(factor(sam_info$rank))),1, "\n", file = cls_file )
  cat("#", paste0(levels(factor(sam_info[, type_name])), collapse = " " ), "\n", file = cls_file, sep = "", append = T)
  cat(as.numeric(factor(sam_info[, type_name])), file = cls_file, append = T)
}

# 创建submap需要的数据格式 (SKCM)
skcm.immunotherapy.logNC <- read.table("skcm.immunotherapy.47samples.log2CountsNorm.txt",sep = "\t",row.names = 1,header = T,check.names = F,stringsAsFactors = F) #原文提供的log2转化的标准化count值
rownames(skcm.immunotherapy.logNC) <- toupper(rownames(skcm.immunotherapy.logNC)) # 基因大写，因为我使用的数据是把基因名都大写的
skcm.immunotherapy.info <- read.table("skcm.immunotherapy.47sampleInfo.txt",sep = "\t",row.names = 1,header = T,check.names = F,stringsAsFactors = F)

skcm.immunotherapy.info <- skcm.immunotherapy.info[order(skcm.immunotherapy.info$label),]
skcm.immunotherapy.info$rank <- rep(c(1,2,3,4),times=as.character(table(skcm.immunotherapy.info$label))) #1: CTLA4_noR 2: CTLA4_R 3:PD1_noR 4:PD1_R

# 创建submap需要的数据格式 (TCGA)
tmp <- read.table("matrix_submapInput.txt",sep = "\t",check.names = F,stringsAsFactors = F,header = T,row.names = 1) 
# submap不允许出现flat value, 因此最好选取过滤掉低表达的表达谱，这里使用的数据过滤了超过90%样本表达值均<1的基因
tmp[1:4,1:4]
cell <- rownames(tmp)[1:nrow(tmp)][sapply(4:nrow(tmp), function(i){
  quantile(tmp[i,],0.1) > 1
}  
)]
tmp <- tmp[cell,]

GENELIST <- intersect(rownames(tmp),rownames(skcm.immunotherapy.logNC)) # 取交集后的基因列表
sam_info <- skcm.immunotherapy.info
in_gct <- skcm.immunotherapy.logNC[GENELIST,rownames(skcm.immunotherapy.info)]

# 产生输出数据的文件名
gct_file <- "skcm.immunotherapy.for.SubMap.gct"
cls_file <- "skcm.immunotherapy.for.SubMap.cls"
generateInputFileForSubMap(in_gct = in_gct, gct_file = gct_file, cls_file = cls_file, sam_info = sam_info, type_name = "rank")

# 提出亚型的样本，顺序排列
samples.C1 <- rownames(ann[which(ann$ImmClust == "C1"),])
samples.C2 <- rownames(ann[which(ann$ImmClust == "C2"),])

sam_info <- data.frame("ImmClust"=c(samples.C1,samples.C2),row.names = c(samples.C1,samples.C2))
sam_info$rank <- rep(c(1,2),times=c(length(samples.C1),length(samples.C2))) #1: C1,即HPV16-IMM 2: C2,即HPV16-KRT

# 产生输出数据的文件名
gct_file <- "Immune2.for.SubMap.gct"
cls_file <- "Immune2.for.SubMap.cls"

in_gct <- log2(tmp[GENELIST,rownames(sam_info)]+1) # 产生和示例数据类似的形式，log2转化的标准化count值
generateInputFileForSubMap(in_gct = in_gct, gct_file = gct_file, cls_file = cls_file, sam_info = sam_info, type_name = "rank")

#--------------------------------------#
# 请参照文件夹submap使用教程完成该部分 #
#--------------------------------------#

# 参照文件夹中submap使用教程得到输出文件SubMap_SubMapResult.txt

#开始画图
heatmap.YlGnPe <- c("#440259","#345F8C","#228C8A","#78CE51","#FAE71F")
cherry    <- "#700353"
lightgrey <- "#dcddde"

# 把submap结果/130452/SubMap_SubMapResult.txt文件中的值填入相应的位置
# 输入文件中的名义p值和校正p值绘制热图
tmp <- matrix(c(0.871,0.889,0.406,0.859,0.147,0.088,0.832,0.039, 
                1,1,1,1,1,0.703,1,0.312), # Bonferroni校正p值
              nrow = 4,byrow = T,dimnames = list(c("High_CuSig_score_p","Low_CuSig_score_p","High_CuSig_score_b","Low_CuSig_score_b"),c("CTAL4-noR","CTLA4-R","PD1-noR","PD1-R")))

library(pheatmap)
pheatmap(tmp, cellwidth = 30, cellheight = 30,
         cluster_rows = F,cluster_cols = F,
         color = heatmap.YlGnPe[5:1],
         gaps_row = 2,
         annotation_row = data.frame(pvalue=c("Nominal p value","Nominal p value","Bonferroni corrected","Bonferroni corrected"),row.names = rownames(tmp)),
         annotation_colors = list(pvalue=c("Nominal p value"=lightgrey,"Bonferroni corrected"=cherry)),
         filename = "heatmap_submap.pdf")
# 原文中热图上的数值是AI后期加上去的。







