#-----------基因去重复-----------
inputFile="E:\\小逗的工作内容\\项目-2021.2.5\\03-进行中项目\\YQ230-11-分析过程\\00-data\\04-TCGA-GTEX\\merge.txt"

library(GSVA)
library(limma)
library(GSEABase)  #getGmt函数进行转换gc

rt=read.table(inputFile,sep="\t",header=T,check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
rt[1:4,1:4]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp),colnames(exp))
mat=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
mat=avereps(mat)
#以上对重复基因进行取均值
#mat=normalizeBetweenArrays(mat)
mat[1:4,1:4]

sy <- cbind(id=rownames(mat),mat)
sy[1:4,1:4]
write.csv(sy,"merge_uniq.csv",row.names = F,quote = F)


############### 1.安装和加载包   #######################################
#安装包（使用国内镜像安装包）
options("repos"= c(CRAN="https://mirrors.tuna.tsinghua.edu.cn/CRAN/"))
options(BioC_mirror="http://mirrors.ustc.edu.cn/bioc/")
install.packages("msigdbr")
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")

BiocManager::install("GSVA")
BiocManager::install("limma")

#加载包
library(msigdbr)
library(dplyr)
library(data.table)
library(GSVA)
library(limma)
library(stringr)
library(ggplot2)

Sys.setenv(LANGUAGE = "en") #显示英文报错信息
options(stringsAsFactors = FALSE) #禁止chr转成factor

################  2.读入数据   #################################################
################   3.GSVA    ####################################################
# 读入前面生成的通路中的基因列表
#(load("hallmark.gs.RData")) #保存在当前文件夹
msigdbr_show_species()

#2.看人类有哪些基因集
human <- msigdbr(species = "Homo sapiens")
human[1:4,1:4]
table(human[,1])
#kegg 在C2,GO 在C5。
h <- msigdbr(species = "Homo sapiens", # 物种拉丁名
             #category = "C2",subcategory = "CP:KEGG") #此处以hallmark为例，你也可以选择MSigDB的其他注释
            category = "C5") 
table(h$gs_subcat)
h <- h[h$gs_subcat!="HPO",]
h <- select(h, gs_name, gene_symbol) %>% #或entrez_gene
  as.data.frame %>% 
  split(., .$gs_name) %>% 
  lapply(., function(x)(x$gene_symbol)) #或entrez_gene

# 在每个geneset里面去掉重复的基因
gs <- lapply(h, unique)

# 接下来去掉那些在两个或更多个pathways里出现过的genes
count <- table(unlist(gs))
keep <- names(which(table(unlist(gs)) < 2))
gs <- lapply(gs, function(x) intersect(keep, x))

# 过滤之后，很多pathway一个gene都不剩了，去掉这些
gs <- gs[lapply(gs, length) > 0]

# 预览过滤后的结果
head(gs)
# 保存到文件，方便以后重复使用
save(gs, file = "GO.gs.RData")



# 读入基因表达矩阵（行-基因名；列-样本）
#gsym.expr <- read.csv("merge_uniq.csv", row.names = 1,check.names = F)
#gsym.expr <- read.table("E:\\小逗的工作内容\\项目-2021.2.5\\03-进行中项目\\YQXX0180\\05-免疫检查点和免疫治疗分析\\01-检查点\\03_TCGA-HNSC_uniq.symbol_544.txt", 
                        #header=T,sep="\t",row.names = 1,check.names=F)
load("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\03_TCGA_BRCA_uniq.symbol_1204.Rdata")
data2[1:4,1:4]
#head(gsym.expr)

load("hallmark.gs.RData")
gsva_es <- gsva(as.matrix(data2), gs) #GSVA分析
head(gsva_es)  # 预览GSVA分析返回的矩阵

# 把通路的表达量保存到文件
write.csv(gsva_es, "gsva_hallmark_output.csv", quote = F)


##############   4.通路的差异表达分析   ##############################
# 分组
#group_list <- data.frame(sample = colnames(gsva_es), group = c(rep("a", 3), rep("b", 3)))
#head(group_list)
##      sample group
## 1 GSM431121     a
## 2 GSM431122     a
## 3 GSM431123     a
## 4 GSM431124     b

# 分组
#risk <-read.table("risk.txt",header=T,sep="\t")
#colnames(risk)

load("06_CuSig_cutpoint.Rdata")
res.cat$group <- ifelse(res.cat$group=="High CuSig score","High_CuSig_score","Low_CuSig_score")
group_list <- res.cat[,c("id","group")]
head(group_list,3)


# 设置对比
design <- model.matrix(~ 0 + factor(group_list$group))
colnames(design) <- levels(factor(group_list$group))
gsva_es <- gsva_es[,group_list$id]
save(gsva_es,file="HALLMARK_sample_exp.Rdata")
save(group_list,file="group_1069.Rdata")
identical(colnames(gsva_es),group_list$id)
rownames(design) <- colnames(gsva_es)
design

# 构建差异比较矩阵
contrast.matrix <- makeContrasts(High_CuSig_score-Low_CuSig_score, levels = design)

# 差异分析，b vs. a
fit <- lmFit(gsva_es, design)
fit2 <- contrasts.fit(fit, contrast.matrix)
fit2 <- eBayes(fit2)
x <- topTable(fit2, coef = 1, n = Inf, adjust.method = "BH", sort.by = "P")
head(x)

#把通路的limma分析结果保存到文件
write.csv(x, "gsva_HALLMARK_limma.csv", quote = F)

#输出t值，用做FigureYa39bar的输入数据
#pathway <- str_replace(row.names(x), "HALLMARK_", "")
pathway <- row.names(x)
df <- data.frame(ID = pathway, score = x$t)
write.csv(df, "HALLMARK_easy_input2_for39bar.csv", quote = F, row.names = F)


###############  5.绘制差异通路图      ######################

df <- read.csv("HALLMARK_easy_input2_for39bar.csv")
head(df)
#按照score的值分组
cutoff <- 2
df$group <- cut(df$score, breaks = c(-Inf, -cutoff, cutoff, Inf),labels = c(1,2,3))

#按照score排序
sortdf <- df[order(df$score),]
sortdf$ID <- factor(sortdf$ID, levels = sortdf$ID)
head(sortdf)

library(ggplot2)
ggplot(sortdf, aes(ID, score, fill = group)) + geom_bar(stat = 'identity') + 
  coord_flip() + 
  scale_fill_manual(values = c('palegreen3', 'snow3', 'dodgerblue4'), guide = "none") + 
  #scale_fill_manual(values = c('palegreen3', 'snow3', 'dodgerblue4'), guide = FALSE) + 
  
  #画2条虚线
  geom_hline(yintercept = c(-cutoff,cutoff), 
             color="white",
             linetype = 2, #画虚线
             size = 0.3) + #线的粗细
  
  #写label
  geom_text(data = subset(df, score> 0),
            aes(x=ID, y= 0, label= paste0(" ", ID), color = group),#bar跟坐标轴间留出间隙
            size = 3, #字的大小
            hjust = "inward" ) +  #字的对齐方式
  geom_text(data = subset(df, score < 0),
            aes(x=ID, y= 0, label=ID, color = group),
            size = 3, hjust = "outward") +  
  scale_colour_manual(values = c("black","snow3","black"), guide = "none") +
  #scale_colour_manual(values = c("black","snow3","black"), guide = FALSE) +
  
  xlab("") +ylab("t value of GSVA score, High_CuSig_score \n versus Low_CuSig_score")+
  theme_bw() + #去除背景色
  theme(panel.grid =element_blank()) + #去除网格线
  theme(panel.border = element_rect(size = 0.6)) + #边框粗细
  theme(axis.line.y = element_blank(), axis.ticks.y = element_blank(), axis.text.y = element_blank()) #去除y轴

ggsave("HALLMARK_gsva.pdf", width = 8, height =9)
###完事儿####################################################################
sessionInfo()



#-------------------riskScore随着HallMark的表达变化--------------------
load("KEGG_sample_exp.Rdata")
load("group_1069.Rdata")
x <- read.csv("gsva_KEGG_limma.csv",row.names = 1)
#xx <- subset(x,abs(x$logFC)>0.1 & x$P.Value<0.05)
cc <- x[order(x$logFC),]

data_fpkm <- data.frame(gsva_es,check.names = F)
data_fpkm[1:4,1:4]
data_fpkm <- data_fpkm[rownames(cc),]



identical(group_list$id,colnames(data_fpkm))
group_list <- group_list[,-1]
group <- data.frame(group=group_list,check.names = F)
rownames(group) <- colnames(data_fpkm)



##2.##样本顺序不一样时,前期应改变样本顺序就可避免这类问题
library(pheatmap)
ann_colors =list(group=c(High_CuSig_score="#D95F02",Low_CuSig_score="#1B9E77"))
pdf(file="KEGG_pheatmap_all.pdf",width=15,height=20)
pheatmap(data_fpkm,color = colorRampPalette(c("navy", "white", "firebrick3"))(50),
         annotation_col = group,
         annotation_colors = ann_colors,
         border_color=NA,
         cluster_rows=TRUE, show_rownames=TRUE,
         fontsize_row=8,show_colnames=F,scale="row",
         cluster_cols=FALSE,main="")
dev.off()


#GSEA的输入准备
data <- data2[,res.cat$id]
data[1:4,1:4]
write.csv(data,"GSEA_input_matrix.csv",quote = F,)

grou <- res.cat[,c(1,ncol(res.cat))]
write.csv(grou,"GSEA_input_grou.csv",quote = F,)



#--------------------riskScore和HALLMARK相关性分析------------------
#install.packages("corrplot")
library(corrplot)

gsva_i <- read.table("gsva_output.csv",header=T,sep=",",check.names = F,row.names = 1)
risk <- read.table("risk.txt",header=T,sep="\t",check.names = F)
colnames(risk)
gsva_1 <- gsva_i[,risk$id]

identical(risk$id,colnames(gsva_1))
riskScore <- data.frame(t(risk[,c(1,13)]))
colnames(riskScore) <-riskScore[1,]
riskScore <- riskScore[-1,]
gsva_2 <- rbind(riskScore=riskScore,gsva_1)
write.csv(gsva_2,"gsva_riskScore.csv")

rt <- as.data.frame(t(gsva_2))
rt[,1:ncol(rt)] <- sapply(rt[,1:ncol(rt)],function(x){as.numeric(x)})
cormat <- round(cor(rt),2)
#cormat <- cor(rt,method="pearson")
head(cormat)
write.csv(cormat,"cor.csv",quote = F)


library(paletteer)
paletteer_c("scico::berlin", n = 10)
paletteer_d("RColorBrewer::Paired")
paletteer_dynamic("cartography::green.pal", 5)

col4 <- colorRampPalette(c("green", "white", "red"))

pdf('cor_circle.pdf',width =8,height = 8)
corrplot(cormat, p.mat = rt$p, 
         col = col4(50), cl.lim = c(0,1),
         insig = "label_sig",
         type = "lower",
         tl.cex=0.5,tl.col="black",
         rect.col="gray",rect.lwd=3,  #矩形框的颜色和宽度
         #p.mat = rt$p, 
         #insig = "p-value",
         sig.level = c(.001, .01, .05), pch.cex = .9, pch.col = "white")
dev.off()



