

###-------------差异分析------------------------------------------------------------
#----------------limma------------------------------
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")

BiocManager::install("edgeR")
library(edgeR)
library(limma)
####################################
#data_FPKM <- read.table("C:\\Users\\Administrator\\Desktop\\YQ170-7\\01-data\\01-TCGA-KIRC\\03_uniq.symbol_KIRC_602.txt",sep="\t",header=T,check.names = F)
data_FPKM <- read.csv("C:\\Users\\Administrator\\Desktop\\243-11\\10-高低评分组GSEA分析\\GSEA_input_matrix.csv",header=T,check.names = F,row.names = 1)
#data_FPKM <- data_FPKM[rowMeans(data_FPKM)>0,]
#load("C:\\Users\\Administrator\\Desktop\\YQXX0541\\00-data\\01-TCGA_KIRC_FPKM\\03_uniq.symbol_KIRC_602.Rdata")
#data_FPKM <- out[,-1]
#load("02_group_shu.Rdata")

data_FPKM[1:3,1:3]
#rownames(data_FPKM) <- data_FPKM[,1]
#data_FPKM <- data_FPKM[,-1]
boxplot(data_FPKM[,500:ncol(data_FPKM)],las=2)    ##查看数据分布，看是否进行标准化
#data_FPKM<-log2(data_FPKM+1)   #标准化
##data_FPKM<-rpkm(data_FPKM,gene.length =2000,normalized.lib.sizes = FALSE,lib.size = NULL,log=TRUE,prior.count =2)


##### 样本不按顺序的时候
#clinical<-read.table("group_H184_L132.txt",sep="\t",header=F)
#clinical<-t(clinical)
#clinical<-data.frame(clinical)
sample <-read.csv("C:\\Users\\Administrator\\Desktop\\243-11\\10-高低评分组GSEA分析\\GSEA_input_grou.csv",sep=",",header=T,row.names = 1)
clinical<- sample
colnames(clinical)<-c("var1","var2")
rownames(clinical)<-clinical$var1
data_FPKM <- data_FPKM[,clinical$var1]  ##由于样本数目不一致

clinical<-clinical[as.vector(colnames(data_FPKM)),]  #如果跑不通这步就#掉
group<-factor(clinical$var2)
design <- model.matrix(~0+group, data=clinical)
colnames(design) <- c(levels(group))
identical(colnames(data_FPKM),rownames(clinical))

fit<-lmFit(data_FPKM,design)
contrast.matrix <- makeContrasts("High_CuSig_score-Low_CuSig_score",levels=design)  ##看clinical文件的命名
fit2<-contrasts.fit(fit,contrast.matrix)
fit2<-eBayes(fit2)
result1<-topTable(fit2,coef=1,adjust="BH",number=dim(data_FPKM)[1])

#write.table(result1,file="DEGs_information.txt",sep="\t",quote=F,row.names=T)
write.csv(result1,file="DEGs_information.csv",quote=F,row.names=T)
save(result1,file="DEGs_information.Rdata")


#########################   logFc=0.5,P.Val=0.05   #######################
colnames(result1)
logFc=0.5
p=0.05
diffSig = result1[(result1$P.Value < p & (result1$logFC>logFc | result1$logFC<(-logFc))),]
diffSig <- cbind(gene=rownames(diffSig),diffSig)
write.table(diffSig, file="diffSig_logFC0.5_p0.05_590.xls",row.names=F,sep="\t",quote=F)
save(diffSig,file="diffSig.Rdata")

#UP
diffUp = result1[(result1$P.Value < p & (result1$logFC>logFc)),]
diffUp <- cbind(gene=rownames(diffUp),diffUp)
write.table(diffUp, file="up_logFC0.5_p0.05_24.xls",row.names=F,sep="\t",quote=F)

#Down
diffDown = result1[(result1$P.Value < p & (result1$logFC<(-logFc))),]
diffDown <- cbind(gene=rownames(diffDown),diffDown)
write.table(diffDown, file="down_logFC0.5_p0.05_566.xls",row.names=F,sep="\t",quote=F)



#-----------------------------火山图+热图---------------------------

##安装和调用ggplot2################
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")
BiocManager::install("ggplot2")
library(ggplot2)

logFc=1
p=0.05

##读入数据#########################
#biowolf<-read.table(file="DEGs_information.txt",header=TRUE,sep="\t",row.names = 1)
biowolf<-read.csv(file="DEGs_information.csv",header=TRUE,sep=",",row.names = 1)
#biowolf <- read.table(file="all.xls",header=TRUE,sep="\t",row.names = 1)
colnames(biowolf)

biowolf$Significant <- ifelse(biowolf$P.Value<p & abs(biowolf$logFC)>=logFc,ifelse(biowolf$logFC>logFc ,'UP','DOWN'),'NOT')
#??logFC??ֵ
Significant <- c(UP = "#FF0000",NOT = "gray",DOWN = "#215E21")
pdf(file="TCGA_KIRC_MA_logFC1_P0.05.pdf",width=8,height=7,onefile=FALSE)
p <- ggplot(biowolf, aes(logFC, -log10(P.Value)))+
  #xlim(-5,5)+ylim(0,50)+geom_point(aes(col = Significant))+theme_bw()+
  ylim(min(-log10(biowolf$P.Value)),max(-log10(biowolf$P.Value)))+xlim(min(biowolf$logFC),max(biowolf$logFC))+
  theme_bw()+geom_point(aes(col = Significant))+
  scale_color_manual(values = Significant)+
  #??DEGs?ĺ?????????????ֵ????Сֵ??��??xlim??ylim??��??֤???̵???ͼ????ʾ  
  labs(title="",x="log2foldchange",y="-log10(P.Value)")+
  geom_hline(yintercept = -log10(0.05), lty=4,col="black",lwd=0.6)+
  geom_vline(xintercept = c(-1, 1), lty=4,col="black",lwd=0.6)+
  theme(plot.title = element_text(hjust = 0.5),
        #legend.position = "none",
        #legend.position = "topright",
        #legend.position =  c(0.95, 0.9),
        #legend=c("Up","Down","nonsignificant"),
        #col=c("red","blue","gray"),
        #legend.margin= T,
        #panel.grid=element_blank(),
        axis.title = element_text(size = 16),
        axis.text = element_text(size = 14))
#xinterceptֵ??logFC?????õ?ֵ??Ӧ??
print(p)
dev.off()


#----------------热图
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")  
BiocManager::install("vsn") 
BiocManager::install("pheatmap") 

library("vsn")
library("pheatmap")

##?????????ȱ???��????????
#data_FPKM <- read.table("diffGeneExp.txt",sep="\t",header=T,check.names = F)   ###用的是基因表达量矩阵，，，横为样本，纵为基因???
#rownames(data_FPKM) <- data_FPKM[,1]
#data_FPKM <- data_FPKM[,-1]
#boxplot(data_FPKM,las=2)
#data_FPKM<-log2(data_FPKM+1.2)
library(dplyr)
load("07_TCGA_diffSig.Rdata")
# DEG <- result1
# up_50<-DEG %>% as_tibble() %>% 
#   mutate(genename=rownames(DEG)) %>% 
#   dplyr::arrange(desc(logFC)) %>% 
#   .$genename %>% .[1:50] ## 管道符中的提取
# ## FC低前50
# down_50<-DEG %>% as_tibble() %>% 
#   mutate(genename=rownames(DEG)) %>% 
#   dplyr::arrange(logFC) %>% 
#   .$genename %>% .[1:50] ## 管道符中的提取
# index<-c(up_50,down_50)

index<-diffSig$gene

load("C:\\Users\\Administrator\\Desktop\\YQXX0541\\00-data\\01-TCGA_KIRC_FPKM\\03_uniq.symbol_KIRC_602.Rdata")
data_FPKM <- out[,-1]
DE_ARG_Exp <- data_FPKM[index,]


Type<-"group_H184_L132.txt"   ##用的数据是limma差异表达分析跑出来的结果，包括gene，Pvalue,adj p等等
ann <-read.table(file=Type,header=F,sep="\t",check.names = F)
group <- t(ann)
group <- data.frame(group)
#library(tidyverse)
#select(ann1,group=1)
group1 <- group[order(group$X2),]
rownames(group1) <- group1$X1
colnames(group1) <- c("id","group")
group33 <- data.frame(group=group1[,-1])
rownames(group33) <- rownames(group1)
group <- group33


DE_ARG_Exp1 <- DE_ARG_Exp[,rownames(group)]
identical(rownames(group),colnames(DE_ARG_Exp1))
#pdf(file="DEGs_pheatmap.pdf",width=12,height=10,onefile=FALSE)
##2.##样本顺序不一样时,前期应改变样本顺序就可避免这类问题
ann_colors =list(group=c(High_risk="#D95F02",Low_risk="#1B9E77"))
pdf(file="TCGA_KIRC_DEGs_pheatmap_risk.pdf",width=7,height=4)
pheatmap(DE_ARG_Exp1,color = colorRampPalette(c("navy", "white", "firebrick3"))(50),
         annotation_col = group,
         annotation_colors = ann_colors,
         border_color=NA,
         cluster_rows=TRUE, show_rownames=TRUE,
         fontsize_row=7,show_colnames=F,scale="row",
         cluster_cols=FALSE,main="")
dev.off()
#clustering_method 参数来指定不同的聚类方法，
# 默认欧式聚类，支持以下几种方法：
# 'ward', 'ward.D', 'ward.D2', 
# 'single', 'complete', 'average', 
# 'mcquitty', 'median', 'centroid'














#-------节律基因火山图---------------------
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")
BiocManager::install("ggplot2")
library(ggplot2)
#load("03_TCGA-HNSC_uniq.symbol_544.Rdata")
load("05_DEGs_information.Rdata")
cir <- read.table("节律相关基因_300.txt",header=T,check.names = F)
cir_gene <- result1[cir$gene,]
cir_gene <- na.omit(cir_gene)
biowolf <- cir_gene
write.csv(biowolf,file="05_标记火山图输入.csv",quote=F,row.names=T)


logFc=1
p=0.05

colnames(biowolf)
biowolf$Significant <- ifelse(biowolf$adj.P.Val<p & abs(biowolf$logFC)>=logFc,ifelse(biowolf$logFC>logFc ,'UP','DOWN'),'NOT')#??logFC??ֵ
Significant <- c(UP = "#FF0000",NOT = "gray",DOWN = "#215E21")
pdf(file="MA_logFC1_adjP0.05.pdf",width=8,height=7,onefile=FALSE)
p <- ggplot(biowolf, aes(logFC, -log10(adj.P.Val)))+
  #xlim(-5,5)+ylim(0,50)+geom_point(aes(col = Significant))+theme_bw()+
  ylim(min(-log10(biowolf$adj.P.Val)),max(-log10(biowolf$adj.P.Val)))+xlim(min(biowolf$logFC),max(biowolf$logFC))+
  theme_bw()+geom_point(aes(col = Significant))+
  scale_color_manual(values = Significant)+
  #??DEGs?ĺ?????????????ֵ????Сֵ??��??xlim??ylim??��??֤???̵???ͼ????ʾ  
  labs(title="",x="log2foldchange",y="-log10(adj.P.Val)")+
  geom_hline(yintercept = -log10(0.05), lty=4,col="black",lwd=0.6)+
  geom_vline(xintercept = c(-1, 1), lty=4,col="black",lwd=0.6)+
  theme(plot.title = element_text(hjust = 0.5),
        #legend.position = "none",
        #legend.position = "topright",
        #legend.position =  c(0.95, 0.9),
        #legend=c("Up","Down","nonsignificant"),
        #col=c("red","blue","gray"),
        #legend.margin= T,
        #panel.grid=element_blank(),
        axis.title = element_text(size = 16),
        axis.text = element_text(size = 14))
#xinterceptֵ??logFC?????õ?ֵ??Ӧ??
print(p)
dev.off()
                    
  
############ 标记火山图  ####################
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")
BiocManager::install(c("ggrepel","ggplot"))

logFc=1
p=0.05

res <- read.csv("05_标记火山图输入.csv")

#定义显著性
library(ggplot2)
library(ggrepel)

#labelGene<- read.csv("top20_gene.csv")$x 
#abelGene<- read.table("top40.txt",header=T) 
#DEGs <- res[order(res$logFC),]
#labelGene<-DEGs$X[c(1:10,19542:19551)]
#labelGene<- diffSig$gene

load("diffSig.Rdata")
labelGene<- diffSig$gene

colnames(res)
res$label <- ifelse(res$X %in% labelGene,res$X,"" )  #要标记的，label=基因，无需标记的，label=""
Significant=ifelse((res$adj.P.Val< p & abs(res$logFC)> logFc), ifelse(res$logFC > logFc,"Up","Down"), "Not")#绘制火山图
p = ggplot(res, aes(logFC, -log10(adj.P.Val),col=Significant))+
  geom_point()+
  #geom_point(alpha=0.4, size=3.5) +
  scale_color_manual(values=c("#004BFB", "#BFBFBF", "#F91F10"))+
  labs(title = " ")+xlab("log2FC")+
  #max(-log10(res$P.Value));min(res$logFC);max(res$logFC)
  xlim(-4,4)+ylim(0,80)+
  geom_vline(xintercept=c(-1,1), colour="black", linetype="dashed")+
  geom_hline(yintercept = -log10(0.05),colour="black", linetype="dashed")+
  theme(plot.title = element_text(size = 16, hjust = 0.5, face = "bold"))+
  theme_bw()
p
p1 <- p +geom_text_repel(data= res,aes(logFC, -log10(adj.P.Val),label = label),
                         size = 3,
                         box.padding = unit(0.5, "lines"),
                         point.padding = unit(0.8, "lines"), 
                         segment.color = "black", 
                         max.overlaps =30,    #调整大会显示多
                         show.legend = FALSE)

p1

#保存为图片
pdf("vocano_DEGs.pdf",width=7,height=6)
print(p1)
dev.off()                  
                    
                    
                    
