#----------------------1.获得铜死亡基因矩阵（加分组）-----------
load("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\03_TCGA_BRCA_uniq.symbol_1204.Rdata")
data2[1:4,1:4]
load("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\04_group.Rdata")
sample[1:4,1:2]
#--导入铜死亡基因
cu <- read.table("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\02-铜死亡基因\\cu_death_gene10.txt")


#---提取铜死亡基因-分组矩阵文件
aim_Exp1 <- data.frame(t(data2[cu$V1,]))
aim_Exp2 <- cbind(id=rownames(aim_Exp1),aim_Exp1)
aim_Exp2[1:4,1:4]

merge <- merge(sample,aim_Exp2,by="id",all=F)
rownames(merge) <- merge[,1]
merge <- merge[,-1]
table(merge$group)
write.csv(merge,"Cu_death_Gene_boxplot_ROC_input.csv",quote = F)
save(merge,file="Cu_death_Gene_boxplot_ROC_input.Rdata")


#---------------PCA------------------------
load("Cu_death_Gene_boxplot_ROC_input.Rdata")
merge[1:4,1:4]
dat <- merge

data <- data.frame(t(dat[,-1]),check.names = F)
#expression_matrix[1:3,1:3]
#head(iris,3)
#dat <- data.frame(t(iris[,-ncol(iris)]))
#dat <- expression_matrix
#iris$Subtype <- iris$Species
#colnames(dat) <- rownames(iris)
identical(colnames(data),rownames(dat))

library("FactoMineR")
library("factoextra")
pca.plot = function(data,col){
  
  df.pca <- PCA(t(data), graph = FALSE)
  fviz_pca_ind(df.pca,
               geom.ind = "point",
               col.ind = col ,
               addEllipses = TRUE,
               #palette ="Set1",
               palette ="jco",
               legend.title = "group"
  )
}

pdf("PCA.pdf",height = 6,width=7)
pca.plot(data,factor(dat$group))
dev.off()


#---------------箱线图----------
library(tidyverse)
library(tidyr)
library(ggplot2)
require(ggpubr)
require(ggsci)
require(cowplot)
library(RColorBrewer)

load("Cu_death_Gene_boxplot_ROC_input.Rdata")
hlaexp2 <- merge
boxdata <- gather(hlaexp2,HLA,exp,2:ncol(hlaexp2))
#boxdata[,'exp'] <- sapply(boxdata[,'exp'],function(x){log2(x+1)})

#group分组列变成factor,boxplot按照L,H排列
table(hlaexp2$group)
boxdata$group <- factor(boxdata$group,levels = c('Normal','Tumor'))

#display.brewer.all()  #显示所有可用颜色
#mycol <- brewer.pal(2,'Dark2')
mycol <- brewer.pal(2,'Set1')[2:1]

#--------------梅花这个
pdf('Cu_death_Gene_box.pdf',width =5.5,height = 4)
ggboxplot(boxdata,x='HLA',y='exp',color ='group',
          ylab = 'Relative Expression',
          xlab ='',palette = mycol,  #nejm #jco #jama#npg#d3#aaas,"aaas"
          add ='jitter',add.params = list(size=0.6,shape=16),   #add ='jitter'
          width=0.5)+
  rotate_x_text(45)+
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=8),
        axis.title = element_text(size=10),
        legend.text = element_text(size=8),
        legend.title = element_text(size=10))+
  stat_compare_means(size = 3,aes(group=group),
                     label = 'p.signif',method = 'wilcox.test',hide.ns = F)  ##检验方法可以改

dev.off()


#-------------多组小提琴箱线图-------------------
pdf('Cu_death_Gene_box_ggplot2.pdf',width =6,height =4)
ggplot(boxdata,aes(x=HLA,y=exp,fill=group))+  ##fill=vs：按vs分组对ggplot全局进行颜色设置
  #geom_violin()+
  geom_boxplot(width=0.6)+
  scale_fill_manual(values= mycol)+
  labs(x = "", y = "Relative Expression",title="", colour = "black") +
  # coord_flip()+  #???????????Ե?
  #facet_grid(.~HLA) +   #????????????
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=12),    ##坐标轴标签的大小
        axis.title = element_text(size=12),   ###纵坐标字的大小
        legend.text = element_text(size=10),
        legend.title = element_text(size=10))+
  stat_compare_means(size =3,aes(group=group),
                     label = 'p.signif',method = 'wilcox.test',hide.ns = F,label.x = 1.5,)+
  theme_bw()+rotate_x_text(45)
dev.off()

# #------------单独画基因
# load("5keyGene_ROC_logis_box.Rdata")
# 
# colnames(dat)
# rt <- dat[order(dat$group),];table(dat$group)
# pdf("CYBA.box.pdf",height=5,width=5)
# ggboxplot(rt, x= 'group', y='CYBA',
#           ylab = "CYBA expression", color = 'group', palette = mycol, merge = "flip", add="jitter")+
#   stat_compare_means(size = 4,aes(group= group),label = 'p.signif',label.x = 1.5, )  # label.x = 0.6, label.y = 6
# dev.off()



