
if (!require("BiocManager"))
  install.packages("BiocManager")
BiocManager::install("maftools")
library(maftools)

ma = read.table('C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\03-突变数据\\TCGA.BRCA.varscan.maf',header = T,sep="\t")
ma[1:4,1:12]
ccc <- ma[,c(5:7,1,9)]

#--导入铜死亡基因
cu <- read.table("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\02-铜死亡基因\\cu_death_gene10.txt")
cu_gene <- ccc[ccc$Hugo_Symbol %in% cu$V1,]
save(cu_gene,file="铜死亡基因详细信息.Rdata")


######### 01.提取差异lnc的位置信息   ################
load("铜死亡基因详细信息.Rdata")
length(unique(cu_gene$Hugo_Symbol))

DElnc <- cu_gene[,1:4]
DElnc <- DElnc[!duplicated(DElnc),]

DElnc$PatientID <- c(rep("1",23))
colnames(DElnc) <- c("chr","start","end","gene","patientID")


############# 02. 画图  ###############
library(circlize)
library(ComplexHeatmap)
circos.clear()  
pdf("Cu_death_gene_circle.pdf",width = 8,height =7)
#circos.par("start.degree" = 90)
circos.par("gap.degree" = rep(c(2, 4), 12))
#circos.par("gap.degree" = c(rep(2, 23),20))
#circos.par(gap.after=c(2,2,2,2,4,4,4,30),"start.degree" = 90)   #开口用到的
circos.initializeWithIdeogram(species = "hg38", chromosome.index = paste0("chr", c(1:22, "X", "Y")))#除去contig
circos.info()


##添加lncRNA信息
#data<-read.csv("bedinput.csv",sep=",",header=TRUE)
data <- DElnc
head(data)
circos.genomicTrackPlotRegion(subset(data,patientID==1), track.height = 0.05, stack = TRUE, bg.border = NA,panel.fun = function(region, value, ...) {circos.genomicPoints(region, value, pch=16,col = "red",border = NA, ...)} )
circos.genomicLabels(data, labels.column = 4, side = "inside",
                    #col = "black", line_col = "black",font = 1,cex = 0.6)
                    col = "black", line_col = "black",font = 0.5,cex = 0.3)

dev.off()


#---------------瀑布图----------------------
library(maftools)
cu <- read.table("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\02-铜死亡基因\\cu_death_gene10.txt")

#--------------------画图------------------
#setwd("C:\\Users\\lexb4\\Desktop\\tcgaTMB\\03.maftools")
maf = read.maf(maf = 'C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\03-突变数据\\TCGA.BRCA.varscan.maf')
maf
write.mafSummary(maf = maf, basename = 'maf')

#pdf(file="summary.pdf",width=7,height=6)
#plotmafSummary(maf = maf, rmOutlier = TRUE, addStat = 'median', dashboard = TRUE, titvRaw = FALSE)
#dev.off()


# 自定义变异类型的颜色
#vc_cols = RColorBrewer::brewer.pal(n = 8, name = 'Paired')
#names(vc_cols) = c(
#  'Frame_Shift_Del',
#  'Missense_Mutation',
#  'Nonsense_Mutation',
#  'Multi_Hit',
#  'Frame_Shift_Ins',
#  'In_Frame_Ins',
#  'Splice_Site',
#  'In_Frame_Del'
#)

#print(vc_cols)

pdf(file="cu_gene.maf_waterfall.pdf",width=7,height=6)
oncoplot(maf = maf,
         #colors = vc_cols,
         genes =cu$V1,fontSize = 0.6 ,showTumorSampleBarcodes = F )
dev.off()

###可以使用 oncostrip 函数展示特定基因在样本中的突变情况，
###此处查看肝癌中关注较多的'TP53','CTNNB1', 'ARID1A'三个基因，如下：
oncostrip(maf = maf, genes = c('TP53','CTNNB1', 'ARID1A'))

