

##################     分组条形图         ###################
#setwd("E:/小逗的工作内容/项目-2021.2.5/01-完成的项目-2020-2021.6/30_YQSYL016_RP_20211029/02-分析过程/YQSYL016/06-GlueGO对诊断基因进行富集分析/00-条形图")

library(ggplot2)
library(RColorBrewer)

#------------------input data
slimgo = read.table("DAVID富集结果.txt",header=T,sep="\t",check.names = F)

slimgo <- slimgo[slimgo$PValue<0.05,]

#将Go term设定为factor，这样生成条形图的排序就按照输入文件的顺序了，否则系统默认按照首字母顺序
slimgo <- slimgo[order(slimgo$Category),]
#slimgo$Term=factor(slimgo$Term,levels=slimgo$Term)

#slimgo$Category <- ifelse(slimgo$Category=="GOTERM_CC_DIRECT","GO_CellularComponent",
# ifelse(slimgo$Category=="GOTERM_MF_DIRECT","GO_MolecularFunction","KEGG"))
table(slimgo$Category)
slimgo$Category <- rep(c("GO_BP","GO_CC","GO_MF","KEGG"),c(5,4,2,8))

#go <- read.table("result_input.txt", sep = "\t", header = T)
#kegg <- read.table("kegg.txt", sep = "\t", header = T)
go <- slimgo
goo <- rbind(head(go[go$Category=="GO_BP",],5),head(go[go$Category=="GO_CC",],4),
             head(go[go$Category=="GO_MF",],2),head(go[go$Category=="KEGG",],8))

unique(goo$Category)
goo$Category <- factor(goo$Category, levels = c("GO_BP","GO_CC", 
                                              "GO_MF","KEGG"))
my<- brewer.pal(6,"Set1")[1:4]


#------------------GO和KEGG画一起的条形图------------------
pdf("GO_KEGG_top10_bar.pdf", width = 10, height = 8)
p <- ggplot(goo, aes(x = factor(Term, levels = rev(Term)), y = -log10(PValue), fill = Category)) + 
  geom_bar(stat = "identity", position = position_dodge(), width = 0.5) +
  scale_fill_manual(values=c("#f08080", "#2ec4b6", "#7b2cbf","#5AA3DAFF")) +
  #scale_fill_manual(values=my) +
 facet_grid(Category~., scales = "free", space = "free") +   #????????????
  geom_text(mapping = aes(label = Count),size=3,vjust=0.5 ,hjust=-0.25)+
  theme(legend.position = "none", 
        axis.text.y = element_text(size = 8,colour = "black"),
        #legend.text = element_text(size = 8),
        #legend.title = element_blank(),
        #legend.key.size = unit(0.2,'cm'),
        axis.title.y = element_text(size = 10, face = "bold"),
        panel.background = element_blank(), 
        axis.line = element_line(colour = "black", size = 0.3),
        plot.title = element_text(size = 10, face = "bold")) +
  labs(x = "", y = "-log10(PValue)",title="", colour = "black") +
  #geom_text(aes(label = rev(factor(Description, levels = Description))), position = position_dodge(1)) +
  coord_flip() + #???????????Ե?
  theme_bw()  #????ͼ?μӿ?
print(p)
dev.off()


#-----------------------GO_KEGG_气泡图--------------
#goo$GeneRatio <- goo$Count/goo$List.Total

#install.packages("")
library(RColorBrewer)

goo1 <- goo[goo$Category!="KEGG",]

pdf("GO_point_top10.pdf", width =9, height =6)
p <- ggplot(goo1, aes(x = factor(Term, levels = rev(Term)), y = -log10(PValue), fill = Category)) + 
  geom_point(aes(size=Count,color=PValue)) +
  scale_color_gradient(low = "blue", high = "red")+
  #scale_fill_manual(values=c("#f08080", "#2ec4b6", "#7b2cbf","#5AA3DAFF")) +
  facet_grid(Category~., scales = "free", space = "free") +   #????????????
  #geom_text(mapping = aes(label = Count),size=3,vjust=0.5 ,hjust=-0.25)+
  theme(legend.position = "none", 
        axis.text.y = element_text(size = 10,face = "bold",colour = "black"),
        axis.text.x = element_text(size = 10,colour = "black"),
        #legend.text = element_text(size = 8),
        #legend.title = element_blank(),
        #legend.key.size = unit(0.2,'cm'),
        axis.title.y = element_text(size = 12, face = "bold",colour = "black"),
        axis.title.x = element_text(size = 12, face = "bold",colour = "black"),
        panel.background = element_blank(), 
        axis.line = element_line(colour = "black", size = 0.5,),
        plot.title = element_text(size = 12, face = "bold")) +
  #labs(x = "", y = "Number of genes",title="", colour = "black") +
  labs(color=expression(PValue),
       size="Count",
       x="",
       y="-log10(PValue)",
       title="")+
  #geom_text(aes(label = rev(factor(Description, levels = Description))), position = position_dodge(1)) +
  coord_flip() + #???????????Ե?
  theme_bw()  #????ͼ?μӿ?
print(p)
dev.off()


#------------------单独BP,CC,MF,和KEGG气泡图--------------------
goo$GeneRatio <- goo$Count/goo$`List Total`
goo$Category

go_single <- goo[goo$Category!="KEGG",]

#install.packages("")
library(RColorBrewer)
pdf("GO_piont_top10.pdf", width = 9, height = 6)
p <- ggplot(go_single, aes(x = factor(Term, levels = rev(Term)), y = GeneRatio)) + 
  geom_point(aes(size=Count,color=PValue)) +
  scale_color_gradient(low = "blue", high = "red")+
  #scale_fill_manual(values=c("#f08080", "#2ec4b6", "#7b2cbf","#5AA3DAFF")) +
  facet_grid(Category~., scales = "free", space = "free") +   #????????????
  #geom_text(mapping = aes(label = Count),size=3,vjust=0.5 ,hjust=-0.25)+
  theme(legend.position = "none", 
        axis.text.y = element_text(size = 8,face = "bold",colour = "black"),
        axis.text.x = element_text(size = 8,colour = "black"),
        #legend.text = element_text(size = 8),
        #legend.title = element_blank(),
        #legend.key.size = unit(0.2,'cm'),
        axis.title.y = element_text(size = 10, face = "bold",colour = "black"),
        axis.title.x = element_text(size = 10, face = "bold",colour = "black"),
        panel.background = element_blank(), 
        axis.line = element_line(colour = "black", size = 0.5,),
        plot.title = element_text(size = 10, face = "bold",hjust = 0.5)) +
  #labs(x = "", y = "Number of genes",title="", colour = "black") +
  labs(color=expression(PValue),
       size="Count",
       x="",
       y="Gene Ratio",
       title="GO")+
  #geom_text(aes(label = rev(factor(Description, levels = Description))), position = position_dodge(1)) +
  coord_flip() + #???????????Ե?
  theme_bw()  #????ͼ?μӿ?
print(p)
dev.off()



#-----------------------------单独BP,CC,MF和KEGG条形图
go_single <- goo[goo$Category!="KEGG",]
print(my)


pdf("KEGG_barplot_top10.pdf", width =7, height = 5)
p <- ggplot(go_single, aes(x = factor(Term, levels = rev(Term)), y = Count)) + 
  geom_bar(stat = "identity", fill = "#E41A1C",position = position_dodge(), width = 0.5) +
  #scale_fill_manual(values=c("#f08080", "#2ec4b6", "#7b2cbf","#5AA3DAFF")) +
  #scale_fill_manual(values=my) +
  #facet_grid(Category~., scales = "free", space = "free") +   #????????????
  geom_text(mapping = aes(label = Count),size=3,vjust=0.5 ,hjust=-0.25)+
  theme(legend.position = "none", 
        axis.text.y = element_text(size = 8,colour = "black"),
        #legend.text = element_text(size = 8),
        #legend.title = element_blank(),
        #legend.key.size = unit(0.2,'cm'),
        axis.title.y = element_text(size = 10, face = "bold"),
        panel.background = element_blank(), 
        axis.line = element_line(colour = "black", size = 0.3),
        plot.title = element_text(size = 10, face = "bold",hjust = 0.5)) +
  labs(x = "", y = "Number of genes",title="KEGG", colour = "black") +
  #geom_text(aes(label = rev(factor(Description, levels = Description))), position = position_dodge(1)) +
  coord_flip() + #???????????Ե?
  theme_bw()  #????ͼ?μӿ?
print(p)
dev.off()

#------------------GO起的条形图------------------
go_single <- goo[goo$Category!="KEGG",]

pdf("GO_top10_bar.pdf", width = 10, height = 6)
p <- ggplot(go_single, aes(x = factor(Term, levels = rev(Term)), y = -log10(PValue), fill = Category)) + 
  geom_bar(stat = "identity", position = position_dodge(), width = 0.5) +
  scale_fill_manual(values=c("#f08080", "#2ec4b6", "#7b2cbf","#5AA3DAFF")) +
  #scale_fill_manual(values=my) +
  facet_grid(Category~., scales = "free", space = "free") +   #????????????
  geom_text(mapping = aes(label = Count),size=3,vjust=0.5 ,hjust=-0.25)+
  theme(legend.position = "none", 
        axis.text.y = element_text(size = 8,colour = "black"),
        #legend.text = element_text(size = 8),
        #legend.title = element_blank(),
        #legend.key.size = unit(0.2,'cm'),
        axis.title.y = element_text(size = 10, face = "bold"),
        panel.background = element_blank(), 
        axis.line = element_line(colour = "black", size = 0.3),
        plot.title = element_text(size = 10, face = "bold")) +
  labs(x = "", y = "-log10(PValue)",title="", colour = "black") +
  #geom_text(aes(label = rev(factor(Description, levels = Description))), position = position_dodge(1)) +
  coord_flip() + #???????????Ե?
  theme_bw()  #????ͼ?μӿ?
print(p)
dev.off()
