

#--------------------------ggvenn
library("ggvenn")#读入包
#install.packages("ggvenn")
library(paletteer)


TCGA_BRCA <- read.table("Tumor-Normal_diffSig_logFC0.5_p0.05_4878.xls",header = T)
C1_C2 <- read.table("C1-vs-C2_diffSig_logFC0.5_p0.05_581.xls",header = T,)
C2_C3 <- read.table("C2-vs-C3_diffSig_logFC0.5_p0.05_705.xls",header =T,)
C1_C3 <- read.table("C1-vs-C3_diffSig_logFC0.5_p0.05_1221.xls",header = T)


intersect_up <- Reduce(function(x,y) intersect(x,y),
                            list(TCGA_BRCA$gene,
                                 C1_C2$gene,
                                 C2_C3$gene,
                                 C1_C3$gene
                                 ),accumulate=F)

#intersect_circRNA1 <- intersect_circRNA[intersect_circRNA!=""]
write.csv(intersect_up,"output_intersect_38.csv",row.names = F)


#----------ggvenn------------------------
#然后，我们将数据呈现成列表形式
x<-list(T_vs_N=TCGA_BRCA$gene,
        C1_vs_C2=C1_C2$gene,
        C2_vs_C3=C2_C3$gene,
        C1_vs_C3=C1_C3$gene) #展示X数据
x

paletteer_c("scico::berlin", n = 10)
paletteer_d("RColorBrewer::Paired")
paletteer_dynamic("cartography::green.pal", 5)
library(RColorBrewer)
#display.brewer.all()
print(brewer.pal(4,"Set1"))
print(brewer.pal(4,"Dark2"))
#?ggvenn

pdf(file="output_ggvenn_38.pdf",width = 7,height = 7)         #ͼƬ?ĸ߶?
ggvenn(x,c("T_vs_N","C1_vs_C2","C2_vs_C3","C1_vs_C3"), 
       fill_color = c("#E41A1C","#377EB8","#4DAF4A","#984EA3"),  #set1
       #fill_color = c("#1B9E77","#D95F02","#7570B3","#E7298A"),
       #fill_color = c("#1F78B4FF","#C37469FF","#287A22FF","#B15928FF"),  #填充颜色
       fill_alpha = 0.5,#改变图形透明度       
       stroke_color="gray",#边界线的颜色       
       stroke_alpha = 0.5,#边界线的透明度       
       #stroke_linetype="dashed",#将边界线转化为虚线       
       text_size = 4)#调节字体大小
dev.off()

#-------提取38个交集基因的矩阵----------
load("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\03_TCGA_BRCA_uniq.symbol_1204.Rdata")
data2[1:4,1:4]

intersect_exp <- data2[intersect_up,]
save(intersect_exp,file="intersect_38_exp.Rdata")



#-----------------免疫检查点相关基因和交集基因venn分析--------------
shuju <- read.table("C:\\Users\\Administrator\\Desktop\\YQXX0541\\00-data\\03-免疫检查点相关基因-ICRGs\\ICRGs_List.txt",sep="\t",header=F)
#shuju <- as.data.frame(t(shuju)) #将数据转为dataframe格式
#shuju <- read_excel("Table_1.xlsx",sheet=1)
#s <- shuju[-1,]
#shuju1 <- as.data.frame(t(s))
#shuju <- shuju1[-1,]
aa <- c(shuju[,1])
for(i in 2:10){
        aa <- c(aa,shuju[,i])
}
print(aa)

#思路：把空白变成NA，再去除
aa[aa ==""] <-NA
aa <- data.frame(aa)
df <-aa[complete.cases(aa),]  #删除NA
dff <- data.frame(df)
a <- dff[!duplicated(dff),]
write.csv(a,"ICRGs_List_282.csv",row.names = F,quote = F)#将结果保存到d盘


ICRGs <- read.csv("ICRGs_List_282.csv",header = T)
up_DEG <- read.csv("output_intersect_up_624.csv",header = T)
down_DEG <- read.csv("output_intersect_down_751.csv",header = T)

DEG <- read.csv("output_intersect_up_down_1375.csv",header = T)

venn <- Reduce(function(x,y) intersect(x,y),list(ICRGs$x,DEG$x),accumulate=F)
write.csv(venn,"output_DE-ICRGs_14.csv",row.names = F)


#----------ggvenn------------------------
#然后，我们将数据呈现成列表形式
x<-list(ICRGs=ICRGs$x,up_DEG=up_DEG$x,down_DEG=down_DEG$x) #展示X数据
x

paletteer_c("scico::berlin", n = 10)
paletteer_d("RColorBrewer::Paired")
paletteer_dynamic("cartography::green.pal", 5)

#?ggvenn

pdf(file="output_DE-ICRGs_14.pdf",width = 8,height = 6)         #ͼƬ?ĸ߶?
ggvenn(x,c("up_DEG","down_DEG","ICRGs"),       
       fill_color = c("#1F78B4FF","#C37469FF","#17692CFF"),  #填充颜色
       fill_alpha = 0.6,#改变图形透明度       
       stroke_color="NA",#边界线的颜色       
       stroke_alpha = 0.5,#边界线的透明度       
       #stroke_linetype="dashed",#将边界线转化为虚线       
       text_size = 4)#调节字体大小
dev.off()


#--------------------提取交集基因的矩阵
load("C:\\Users\\Administrator\\Desktop\\YQXX0541\\00-data\\01-TCGA_KIRC_FPKM\\03_uniq.symbol_KIRC_602.Rdata")
out[1:4,1:4]

OS <- out[out$id %in% venn,]
OS[1:4,1:4]
save(OS,file="01_TCGA_KIRC_14VennGene_Exp.Rdata")
write.csv(OS,"01_TCGA_KIRC_14VennGene_Exp.csv",row.names = F)






#---------------15个疾病靶点和24061个药物靶点取交集---------------
mol <- read.csv("mol_15_TargetGene.csv",header = F)

intersect_gene <- Reduce(function(x,y) intersect(x,y),
                            list(mol$V1,intersect_circRNA),accumulate=F)


write.csv(intersect_gene,"output_Sepsis_drug_15.csv",row.names = F)


#----------ggvenn------------------------
#然后，我们将数据呈现成列表形式
x<-list(Drug=mol$V1,Sepsis=intersect_circRNA) #展示X数据
x

paletteer_c("scico::berlin", n = 10)
paletteer_d("RColorBrewer::Paired")
paletteer_dynamic("cartography::green.pal", 5)
library(RColorBrewer)
display.brewer.all()
print(brewer.pal(4,"Set1"))
print(brewer.pal(4,"Dark2"))
#?ggvenn

pdf(file="output_ggvenn_15gene.pdf",width = 9,height = 6)         #ͼƬ?ĸ߶?
ggvenn(x,c("Drug","Sepsis"), 
       fill_color = c("#377EB8","#E41A1C"),  #set1
       #fill_color = c("#1B9E77","#D95F02","#7570B3","#E7298A"),
       #fill_color = c("#1F78B4FF","#C37469FF","#287A22FF","#B15928FF"),  #填充颜色
       fill_alpha = 0.4,#改变图形透明度       
       stroke_color="NA",#边界线的颜色       
       stroke_alpha = 0.5,#边界线的透明度       
       #stroke_linetype="dashed",#将边界线转化为虚线       
       text_size = 4)#调节字体大小
dev.off()




#-----------------mir和靶基因的对应关系-----------
venn_mir <- read.csv("output_venn_167.csv",header=T)


venn_mir_m <- miRTarBase1[miRTarBase1$V2 %in% venn_mir$x,]
mir_gene <- venn_mir_m[!duplicated(venn_mir_m),]
length(unique(mir_gene$V1));length(unique(mir_gene$V2))
#4-----167gene


venn_mir_miRDB <- miRDB1[miRDB1$V2 %in% venn_mir$x,]
mir_gene_miRDB <- venn_mir_miRDB[!duplicated(venn_mir_miRDB),]
length(unique(mir_gene_miRDB$V1));length(unique(mir_gene_miRDB$V2))
#4-----167gene


venn_mir_TargetScan1 <- TargetScan1[TargetScan1$V2 %in% venn_mir$x,]
mir_gene_TargetScan1 <- venn_mir_TargetScan1[!duplicated(venn_mir_TargetScan1),]
length(unique(mir_gene_TargetScan1$V1));length(unique(mir_gene_TargetScan1$V2))
#4-----167gene


venn_mir_mirDIP <- mirDIP[mirDIP$Gene.Symbol %in% venn_mir$x,]
mir_gene_mirDIP <- venn_mir_mirDIP[!duplicated(venn_mir_mirDIP),]
length(unique(mir_gene_mirDIP$Gene.Symbol));length(unique(mir_gene_mirDIP$MicroRNA))
#4-----167gene
mir_gene_mirDIP2 <- mir_gene_mirDIP[,c(4,1)]
colnames(mir_gene_mirDIP2) <- c("V1","V2")


#--------------------合并
whole <- rbind(mir_gene,mir_gene_miRDB,mir_gene_TargetScan1,mir_gene_mirDIP2)
whole1 <- whole[!duplicated(whole),]
length(unique(whole1$V1));length(unique(whole1$V2))
write.table(whole1,"network_4_167.txt",sep="\t",quote = F,row.names = F)


gene <- data.frame(gene=whole$V2)
gene1 <- gene[!duplicated(gene),]
write.table(gene1,"gene_167.txt",sep="\t",quote = F,row.names = F)


